<?php
/*
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}
/*
 * Export logs in csv format
 */
if(!function_exists('ualpExportUserLogCSV')){
    function ualpExportUserLogCSV($userrole,$username,$type,$ip,$country,$user_agent,$time,$start_date,$end_date,$hook,$favorite,$search,$t_session) {
        global $wpdb, $query, $externaldb;
        $Header = array();
        $where = " where 1 = 1";
        if(isset($userrole) && $userrole != ''){
            $where.=" AND user_role like '$userrole'";
        }
        if(isset($username) && $username != ''){
            $where.=" AND user_name like '$username'";
        }
        if(isset($type) && $type != ''){
            $where.=" AND object_type like '$type'";
        }
        if(isset($ip) && $ip != ''){
            $where.=" AND ip_address like '$ip'";
        }
        if(isset($country) && $country != ''){
            $where.=" AND country like '$country'";
        }
        if(isset($user_agent) && $user_agent != ''){
            $where.=" AND user_agent like '$user_agent'";
        }
        if(isset($hook) && $hook != ''){
            $where.=" AND hook like '$hook'";
        }
        if(isset($favorite) && $favorite != ''){
            $where.=" AND favorite like '$favorite'";
        }
        if(isset($t_session) && $t_session != ''){
            $where.=" AND t_session like '$t_session'";
        }
        if(isset($time) && $time != ''){
            $current_time = current_time('timestamp');

            $start_time = '';
            $end_time = '';

            if($time == 'today'){
                $start_time = $current_time;
                $end_time = strtotime('+1 day', $current_time);
            }elseif ($time === 'yesterday') {
                $start_time = strtotime('yesterday', $start_time);
                $end_time = $current_time;
            } elseif ($time === 'week') {
                $start_time = strtotime('-1 week', $start_time);
                $end_time = strtotime('+1 day', $current_time);
            } 
            elseif ($time === 'this-month') {
                $start_time = date('Y-m-01');
                $start_time = strtotime($start_time);

                $end_time = date('Y-m-31');
                $end_time = strtotime($end_time);
            }
            elseif ($time === 'month') {
                $start_time = strtotime('-1 month', $start_time);
                $end_time = strtotime('+1 day', $current_time);
            }
            elseif ($time === '2-month') {
                $start_time = strtotime('-2 month', $start_time);
                $end_time = strtotime('+1 day', $current_time);
            }
            elseif ($time === '3-month') {
                $start_time = strtotime('-3 month', $start_time);
                $end_time = strtotime('+1 day', $current_time);
            }
            elseif ($time === '6-month') {
                $start_time = strtotime('-6 month', $start_time);
                $end_time = strtotime('+1 day', $current_time);
            }
            elseif ($time === 'this-year') {
                $start_time = date('Y-01-01');
                $start_time = strtotime($start_time);

                $end_time = date('Y-12-31');
                $end_time = strtotime($end_time);
            }
            elseif ($time === 'last-year') {
                $start_time = date('Y-01-01');
                $start_time = strtotime($start_time);
                $start_time = strtotime('-1 year',$start_time);

                $end_time = date('Y-12-31');
                $end_time = strtotime($end_time);
                $end_time = strtotime('-1 year',$end_time);
            }
            elseif ($time === 'custom') {
                if(isset($start_date) && $start_date != ''){
                    $start_time = strtotime($start_date);
                    $start_time = strtotime('-1 day', $start_time);
                }
                if(isset($end_date) && $end_date != ''){
                    $end_time = strtotime($end_date);
                    $end_time = strtotime('+1 day', $end_time);
                }
            }
            if($start_time != '') {
                $start_time = date('Y-m-d',$start_time);
                $where .= " AND modified_date > '$start_time' ";
            }
            if($end_time != '') {
                $end_time = date('Y-m-d',$end_time);
                $where .= " AND modified_date < '$end_time'";
            }
        }
        if (isset($search) && $search != "") {
            $where.=" AND user_name like '$search' or user_role like '$search' or object_type like '$search' or action like '$search'";
        }

        $getLogQuery = "SELECT * FROM ".UALP_TABLENAME." $where";
        $resultLogQuery = $externaldb->get_results($getLogQuery);
        $CSVContent = array();
        $c = 0;
        $date_format = get_option('date_format');
        $time_format = get_option('time_format');
        $logged_head = '';

        if (!empty($resultLogQuery)) {
            foreach ($resultLogQuery as $resultLog) {
                $c++;
                $resultLog = (array)$resultLog;
                if(!ualpAllowIp()) {
                    if (isset($resultLog['ip_address'])) {
                        unset($resultLog['ip_address']);
                    }
                }
                if(!ualpAllowCountry()) {
                    if (isset($resultLog['country'])) {
                        unset($resultLog['country']);
                    }
                }
                if(!ualpAllowUserAgent()) {
                    if (isset($resultLog['user_agent'])) {
                        unset($resultLog['user_agent']);
                    }
                }
                if(isset($resultLog['uactid'])) {
                    $resultLog['uactid'] = $c;
                }
                if(isset($resultLog['favorite'])) {
                    if($resultLog['favorite'] == 1) {
                        $resultLog['favorite'] = 'Yes';
                    }
                    elseif($resultLog['favorite'] == 0) {
                        $resultLog['favorite'] = 'No';
                    }
                }
                if(isset($resultLog['modified_date'])) {
                    $get_date = strtotime($resultLog['modified_date']);
                    $date = date($date_format, $get_date);
                    $time = date($time_format, $get_date);
                    $resultLog['modified_date'] = $date . " " . $time;
                }
                if(isset($resultLog['description'])) {
                    if($resultLog['description'] == ''){
                        $action = $post_title = '';
                        $action = $resultLog['action'];
                        $post_title = $resultLog['post_title'];
                        $resultLog['description'] = $action .' : '. $post_title;
                    } else {
                        $resultLog['description'] = html_entity_decode($resultLog['description']);
                    }
                }
                unset($resultLog['post_id']);
                unset($resultLog['user_id']);
                unset($resultLog['post_title']);
                unset($resultLog['action']);
                
                if($logged_head != 'yes') {
                    foreach ($resultLog as $resultLogKey => $resultLogVal) {                    
                        if (!in_array($resultLogKey, $Header)) {
                            $Header[] = $resultLogKey;
                        }
                    }
                    $resultLog[$resultLogKey] = html_entity_decode($resultLogVal);
                }
                $logged_head = 'yes';
                $CSVContent[] = $resultLog;
            }
        }
        $Header = array_values($Header);
        for($h=0;$h<sizeof($Header);$h++){
            if($Header[$h] == 'uactid'){
                $Header[$h] = esc_html__('Sr No.', 'user_activity_log_pro');
            }
            if($Header[$h] == 'user_name'){
                $Header[$h] = esc_html__('Author Name', 'user_activity_log_pro');
            }
            if($Header[$h] == 'user_role'){
                $Header[$h] = esc_html__('Author Role', 'user_activity_log_pro');
            }
            if($Header[$h] == 'user_email'){
                $Header[$h] = esc_html__('Author E-mail', 'user_activity_log_pro');
            }
            if(ualpAllowIp()) {
                if($Header[$h] == 'ip_address'){
                    $Header[$h] = esc_html__('IP Address', 'user_activity_log_pro');
                }
            }
            if(ualpAllowCountry()) {
                if($Header[$h] == 'country'){
                    $Header[$h] = esc_html__('Country', 'user_activity_log_pro');
                }
            }
            if(ualpAllowUserAgent()) {
                if($Header[$h] == 'user_agent'){
                    $Header[$h] = esc_html__('User Agent', 'user_activity_log_pro');
                }
            }
            if($Header[$h] == 'modified_date'){
                $Header[$h] = esc_html__('Date', 'user_activity_log_pro');
            }
            if($Header[$h] == 'object_type'){
                $Header[$h] = esc_html__('Activity Type', 'user_activity_log_pro');
            }
            if($Header[$h] == 'hook'){
                $Header[$h] = esc_html__('Activity Hook', 'user_activity_log_pro');
            }
            if($Header[$h] == 'description'){
                $Header[$h] = esc_html__('Description', 'user_activity_log_pro');
            }
            if($Header[$h] == 'favorite'){
                $Header[$h] = esc_html__('Favorite?', 'user_activity_log_pro');
            }
            if($Header[$h] == 't_session'){
                $Header[$h] = esc_html__('T Session', 'user_activity_log_pro');
            }
            
        }
        $export_delimiter = ',';
        $random_id = rand();
        $csv_file_name = "export_user_logs_" . date("Y-m-d_H-i-s", time()) . ".csv";
        ualpCSVOutput($csv_file_name, $CSVContent, $Header, $export_delimiter);
        do_action('ualp_export_activity_log');
    }
}

if(!function_exists('ualpCSVOutput')){
    function ualpCSVOutput($filename = null, $data = array(), $fields = array(), $delimiter = null) {
        if ($delimiter === null) {
            $delimiter = ',';
        }
        $random_id = rand();
        $filename = "export_user_logs_" . date("Y-m-d_H-i-s", time()) . ".csv";
        if ($filename) {
            $data = ualpUnparse($data, $fields, null, null, $delimiter);
            header('Content-type: application/csv');
            header('Content-Disposition: attachment; filename="' . $filename . '"');
            echo $data;
        }
        return $data;
    }
}

if(!function_exists('ualpUnparse')){
    function ualpUnparse($data = array(), $fields = array(), $append = false, $is_php = false, $delimiter = null) {
        $linefeed = "\r\n";
        $string = ($is_php) ? "<?php header('Status: 403'); die(' '); ?>" . $linefeed : '';
        $entry = array();
        // create heading
        if (!empty($fields)) {
            foreach ($fields as $key => $value) {
                $entry[] = ualpEncloseValue($value);
            }
            $string .= implode($delimiter, $entry) . $linefeed;
            $entry = array();
        }
        // create data
        foreach ($data as $key => $row) {
            foreach ($row as $field => $value) {
                $entry[] = ualpEncloseValue($value);
            }
            $string .= implode($delimiter, $entry) . $linefeed;
            $entry = array();
        }
        return $string;
    }
}

if(!function_exists('ualpEncloseValue')){
    function ualpEncloseValue($value = null) {
        $this_delimiter = ',';
        $this_enclosure = '"';
        if ($value !== null && $value != '') {
            $delimiter = preg_quote($this_delimiter, '/');
            $enclosure = preg_quote($this_enclosure, '/');
            if ($value[0] == '=')
                $value = "'" . $value;
            if (preg_match("/" . $delimiter . "|" . $enclosure . "|\n|\r/i", $value) || ($value{0} == ' ' || substr($value, -1) == ' ')) {
                $value = str_replace($this_enclosure, $this_enclosure . $this_enclosure, $value);
                $value = $this_enclosure . $value . $this_enclosure;
            }
        }
        return $value;
    }
}
add_action('admin_init','ualp_export_log');
if(!function_exists('ualp_export_log')){
    function ualp_export_log(){
        if (is_admin()) {
            if (isset($_GET['export']) && $_GET['export'] == 'user_logs' && isset($_GET['export-nonce']) && $_GET['export-nonce'] != "") {
                $userrole = $username = $type = $ip = $time = $search = $start_date = $end_date = $user_agent = $t_session = "";
                if(isset($_GET['userrole'])){
                    $userrole = sanitize_text_field($_GET['userrole']);
                }
                if(isset($_GET['username'])){
                    $username = sanitize_text_field($_GET['username']);
                }
                if(isset($_GET['type'])){
                    $type = sanitize_text_field($_GET['type']);
                }
                if(isset($_GET['ip'])){
                    $ip = sanitize_text_field($_GET['ip']);
                }
                if(isset($_GET['country'])){
                    $country = sanitize_text_field($_GET['country']);
                }
                if(isset($_GET['user_agent'])){
                    $user_agent = sanitize_text_field($_GET['user_agent']);
                }
                if(isset($_GET['time'])){
                    $time = sanitize_text_field($_GET['time']);
                }
                if(isset($_GET['hook'])){
                    $hook = sanitize_text_field($_GET['hook']);
                }
                if(isset($_GET['favorite'])){
                    $favorite = sanitize_text_field($_GET['favorite']);
                }
                if(isset($_GET['txtsearch'])){
                    $search = sanitize_text_field($_GET['txtsearch']);
                }
                if(isset($_GET['start_date'])){
                    $start_date = sanitize_text_field($_GET['start_date']);
                }
                if(isset($_GET['end_date'])){
                    $end_date = sanitize_text_field($_GET['end_date']);
                }
                if(isset($_GET['t_session'])){
                    $t_session = sanitize_text_field($_GET['t_session']);
                }
                ualpExportUserLogCSV($userrole,$username,$type,$ip,$country,$user_agent,$time,$start_date,$end_date,$hook,$favorite,$search,$t_session);
                exit();
            }
        }
    }
}

/*
 * Send CSv file in email
 */
if(!function_exists('ualpSendCsvInEmail')){
    function ualpSendCsvInEmail(){
        $current_user = wp_get_current_user();
        $f_name = $current_user->user_firstname;
        $l_name = $current_user->user_lastname;
        $to = get_option('ualpToEmail');
        $from = get_option('ualpFromEmail');
        $headers = "MIME-Version: 1.0;\r\n";
        $headers .= "From: " . strip_tags($from) . "\r\n";
        $headers .= "Content-Type: text/html; charset: utf-8;\r\n";
        $headers .= "X-Priority: 3\r\n";
        $headers .= "X-Mailer: PHP" . phpversion() . "\r\n";
        $subject = esc_html__('User Activity Log file', 'user_activity_log_pro').' - '.__('User Activity Log Pro', 'user_activity_log_pro');
        $attachment = ualpGenerateCsvAttachment();
        $body = '';
        ob_start();
        ?>
        <div style="background: #F5F5F5; border-width: 1px; border-style: solid; padding-bottom: 20px; margin: 0px auto; width: 750px; height: auto; border-radius: 3px 3px 3px 3px; border-color: #5C5C5C;">
            <div style="border: #FFF 1px solid; background-color: #ffffff !important; margin: 20px 20px 0;height: auto; -moz-border-radius: 3px; padding-top: 15px;">
                <div style="padding: 20px 20px 20px 20px; font-family: Arial, Helvetica, sans-serif;height: auto; color: #333333; font-size: 13px;">
                    <div style="width: 100%;">
                        <strong><?php esc_html_e('Dear', 'user_activity_log_pro'); ?> <?php echo $f_name; ?> </strong>,<br /><br />
                        <?php esc_html_e('Here is the attachment of users activity log file of your', 'user_activity_log_pro'); ?> <a href="<?php echo home_url(); ?>"><?php esc_html_e('website', 'user_activity_log_pro'); ?></a>.<br /><br />
                    </div>
                </div>
            </div>
        </div>
        <?php
        $body = ob_get_clean();
        $sent = wp_mail($to, $subject, $body, $headers, $attachment);
        return $sent;
    }
}

if(!function_exists('ualpGenerateCsvAttachment')){
    function ualpGenerateCsvAttachment() {
        global $wpdb, $query, $externaldb;
        $c = 0;
        $CSVContent = array();
        $Header = array();
        $date_format = get_option('date_format');
        $time_format = get_option('time_format');

        $csvFilePath = WP_CONTENT_DIR . "/uploads/export_user_logs" . "_" . date("Y-m-d_H-i-s", time()) . ".csv";
        $ualpFileHandler = fopen($csvFilePath, 'w');
        $getLogQuery = "SELECT * FROM ".UALP_TABLENAME;

        $resultLogQuery = $externaldb->get_results($getLogQuery);
        $result = $externaldb->get_col($getLogQuery);

        if ($ualpFileHandler === FALSE) {
            wp_die( esc_html__( 'Failed to open export file', 'user_activity_log_pro' ) );
        }
        if (!empty($resultLogQuery)) {
            foreach ($resultLogQuery as $resultLog) {
                foreach ($resultLog as $resultLogKey => $resultLogVal) {
                    if($resultLogKey != 'post_id' && $resultLogKey != 'user_id'  && $resultLogKey != 'post_title' && $resultLogKey != 'action'){
                        if (!in_array($resultLogKey, $Header)) {
                            $Header[] = $resultLogKey;
                        }
                    }
                }
            }
        }
        foreach ($Header as $header_key) {
            if (is_array($resultLogQuery)) {
                foreach ($resultLogQuery as $key => $val) {
                    $c++;
                    if (array_key_exists($header_key, $val)) {
                        if ($header_key == 'uactid') {
                            $CSVContent[$key][$header_key] = $c;
                        } elseif ($header_key == 'favorite') {
                            if($resultLogQuery[$key]->$header_key == 1){
                                $CSVContent[$key][$header_key] = "Yes";
                            }
                            if($resultLogQuery[$key]->$header_key == 0){
                                $CSVContent[$key][$header_key] = "No";
                            }
                        } elseif ($header_key == 'modified_date') {
                            $get_date = strtotime($resultLogQuery[$key]->$header_key);
                            $date = date($date_format, $get_date);
                            $time = date($time_format, $get_date);
                            $CSVContent[$key][$header_key] = $date . " " . $time;
                        } elseif ($header_key == 'description') {
                            if($resultLogQuery[$key]->$header_key == ''){
                                $action = $post_title = '';
                                $action = $resultLogQuery[$key]->action;
                                $post_title = $resultLogQuery[$key]->post_title;
                                $CSVContent[$key][$header_key] = $action .' : '. $post_title;
                            } else {
                                $CSVContent[$key][$header_key] = html_entity_decode($resultLogQuery[$key]->$header_key);
                            }
                        } else {
                            $CSVContent[$key][$header_key] = " : ".html_entity_decode($resultLogQuery[$key]->$header_key)." : ";
                        }
                    } else {
                        $CSVContent[$key][$header_key] = null;
                    }
                }
            }
        }
        for($h=0;$h<sizeof($Header);$h++){
            if($Header[$h] == 'uactid'){
                $Header[$h] = esc_html__('Sr No.', 'user_activity_log_pro');
            }
            if($Header[$h] == 'user_name'){
                $Header[$h] = esc_html__('Author Name', 'user_activity_log_pro');
            }
            if($Header[$h] == 'user_role'){
                $Header[$h] = esc_html__('Author Role', 'user_activity_log_pro');
            }
            if($Header[$h] == 'user_email'){
                $Header[$h] = esc_html__('Author E-mail', 'user_activity_log_pro');
            }
            if(ualpAllowIp()) {
                if($Header[$h] == 'ip_address'){
                    $Header[$h] = esc_html__('IP Address', 'user_activity_log_pro');
                }
            }
            if(ualpAllowCountry()) {
                if($Header[$h] == 'country'){
                    $Header[$h] = esc_html__('Country', 'user_activity_log_pro');
                }
            }
            if($Header[$h] == 'modified_date'){
                $Header[$h] = esc_html__('Date', 'user_activity_log_pro');
            }
            if($Header[$h] == 'object_type'){
                $Header[$h] = esc_html__('Activity Type', 'user_activity_log_pro');
            }
            if($Header[$h] == 'hook'){
                $Header[$h] = esc_html__('Activity Hook', 'user_activity_log_pro');
            }
            if($Header[$h] == 'description'){
                $Header[$h] = esc_html__('Description', 'user_activity_log_pro');
            }
            if($Header[$h] == 'favorite'){
                $Header[$h] = esc_html__('Favorite?', 'user_activity_log_pro');
            }
            if($Header[$h] == 't_session'){
                $Header[$h] = esc_html__('T session', 'user_activity_log_pro');
            }
        }
        fputcsv($ualpFileHandler, $Header);
        foreach ($CSVContent as $record) {
            fputcsv($ualpFileHandler, $record);
        }
        rewind($ualpFileHandler);
        fclose($ualpFileHandler);
        return $csvFilePath;
    }
}

/*
 * Export User activity logged in csv format
 */
if(!function_exists('ualpExportUserLoggedLogCSV')){
    function ualpExportUserLoggedLogCSV($username,$ip,$country,$user_agent,$search,$loginstatus,$timelogin,$timelogout) {
        global $wpdb, $query, $externaldb;
        $Header = array();
        $where = " where 1 = 1";
        if(isset($username) && $username != ''){
            $where.=" AND user_name like '$username'";
        }
        if(isset($ip) && $ip != ''){
            $where.=" AND ip_address like '$ip'";
        }
        if(isset($country) && $country != ''){
            $where.=" AND country like '$country'";
        }
        if(isset($user_agent) && $user_agent != ''){
            $where.=" AND user_agent like '$user_agent'";
        }
        if (isset($search) && $search != "") {
            $where.=" AND user_name like '$search'";
        }
        if (isset($loginstatus) && $loginstatus != "") {
            $where.=" AND login_status like '$loginstatus'";
        }
        if (isset($timelogin) && $timelogin != "") {
            $where.=" AND time_login like '$timelogin'";
        }
        if (isset($timelogout) && $timelogout != "") {
            $where.=" AND time_logout like '$timelogout'";
        }
        $getLogQuery = "SELECT * FROM ".UALP_LOGIN_TABLENAME." $where";
        $resultLogQuery = $externaldb->get_results($getLogQuery);
        $CSVContent = array();
        $c = 0;
        $date_format = get_option('date_format');
        $time_format = get_option('time_format');
        $logged_head = '';

        if (!empty($resultLogQuery)) {
            foreach ($resultLogQuery as $resultLog) {
                $c++;
                $resultLog = (array)$resultLog;
                if(!ualpAllowIp()) {
                    if (isset($resultLog['ip_address'])) {
                        unset($resultLog['ip_address']);
                    }
                }
                if(!ualpAllowCountry()) {
                    if (isset($resultLog['country'])) {
                        unset($resultLog['country']);
                    }
                }
                if(isset($resultLog['uacltid'])) {
                    $resultLog['uacltid'] = $c;
                }
                if(isset($resultLog['time_login'])) {
                    $time_login = strtotime($resultLog['time_login']);
                    $date = date($date_format, $time_login);
                    $time = date($time_format, $time_login);
                    $resultLog['time_login'] = $date . " " . $time;
                }
                if(isset($resultLog['time_logout'])) {
                    $time_logout = strtotime($resultLog['time_logout']);
                    $date = date($date_format, $time_logout);
                    $time = date($time_format, $time_logout);
                    $resultLog['time_logout'] = $date . " " . $time;
                }
                if(isset($resultLog['time_last_seen'])) {
                    $time_last_seen = strtotime($resultLog['time_last_seen']);
                    $date = date($date_format, $time_last_seen);
                    $time = date($time_format, $time_last_seen);
                    $resultLog['time_last_seen'] = $date . " " . $time;
                }
                if(isset($resultLog['user_agent'])) {
                    $resultLog['user_agent'] = $resultLog['user_agent'];
                } else {
                    $resultLog['user_agent'] = '';
                }
                unset($resultLog['user_role']);
                unset($resultLog['expiration']);
                unset($resultLog['session_token']);
                unset($resultLog['user_id']);
                unset($resultLog['action']);
                if($logged_head != 'yes') {
                    foreach ($resultLog as $resultLogKey => $resultLogVal) {                    
                        if (!in_array($resultLogKey, $Header)) {
                            $Header[] = $resultLogKey;
                        }
                    }
                    $resultLog[$resultLogKey] = html_entity_decode($resultLogVal);
                }
                $logged_head = 'yes';
                $CSVContent[] = $resultLog;
            }
        }
        $Header = array_values($Header);
        for($h=0;$h<sizeof($Header);$h++){
            if($Header[$h] == 'uacltid'){
                $Header[$h] = esc_html__('Sr No.', 'user_activity_log_pro');
            }
            if($Header[$h] == 'user_name'){
                $Header[$h] = esc_html__('Author Name', 'user_activity_log_pro');
            }
            if($Header[$h] == 'user_email'){
                $Header[$h] = esc_html__('Author E-mail', 'user_activity_log_pro');
            }
            if(ualpAllowIp()) {
                if($Header[$h] == 'ip_address'){
                    $Header[$h] = esc_html__('IP Address', 'user_activity_log_pro');
                }
            }
            if(ualpAllowCountry()) {
                if($Header[$h] == 'country'){
                    $Header[$h] = esc_html__('Country', 'user_activity_log_pro');
                }
            }
            if(ualpAllowUserAgent()) {
                if($Header[$h] == 'user_agent'){
                    $Header[$h] = esc_html__('User Agent', 'user_activity_log_pro');
                }
            }
            if($Header[$h] == 'time_login'){
                $Header[$h] = esc_html__('Logged in Time', 'user_activity_log_pro');
            }
            if($Header[$h] == 'time_logout'){
                $Header[$h] = esc_html__('Logged out Time', 'user_activity_log_pro');
            }
            if($Header[$h] == 'time_last_seen'){
                $Header[$h] = esc_html__('Last seen', 'user_activity_log_pro');
            }
            if($Header[$h] == 'login_status'){
                $Header[$h] = esc_html__('Login Status', 'user_activity_log_pro');
            }
        }
        $export_delimiter = ',';
        $random_id = rand();
        $csv_file_name = "export_user_logged_" . date("Y-m-d_H-i-s", time()) . ".csv";
        ualploggedCSVOutput($csv_file_name, $CSVContent, $Header, $export_delimiter);
        do_action('ualp_export_activity_log');
    }
}

if(!function_exists('ualploggedCSVOutput')){
    function ualploggedCSVOutput($filename = null, $data = array(), $fields = array(), $delimiter = null) {
        if ($delimiter === null) {
            $delimiter = ',';
        }
        $random_id = rand();
        $filename = "export_user_logged_" . date("Y-m-d_H-i-s", time()) . ".csv";
        if ($filename) {
            $data = ualpUnparse($data, $fields, null, null, $delimiter);
            header('Content-type: application/csv');
            header('Content-Disposition: attachment; filename="' . $filename . '"');
            echo $data;
        }
        return $data;
    }
}

add_action('admin_init','ualp_export_user_logged');
if(!function_exists('ualp_export_user_logged')){
    function ualp_export_user_logged(){
        if (is_admin()) {
            if (isset($_GET['export']) && $_GET['export'] == 'user_login' && isset($_GET['export-nonce']) && $_GET['export-nonce'] != "") {
               $username = $ip = $timelogin = $search = $user_agent = $country = $loginstatus = $timelogout = $user_role = "";
                
                if(isset($_GET['username'])){
                    $username = sanitize_text_field($_GET['username']);
                }
                if(isset($_GET['ip'])){
                    $ip = sanitize_text_field($_GET['ip']);
                }
                if(isset($_GET['country'])){
                    $country = sanitize_text_field($_GET['country']);
                }
                if(isset($_GET['user_agent'])){
                    $user_agent = sanitize_text_field($_GET['user_agent']);
                }
                if(isset($_GET['loginstatus'])){
                    $loginstatus = sanitize_text_field($_GET['loginstatus']);
                }
                if(isset($_GET['timelogin'])){
                    $timelogin = sanitize_text_field($_GET['timelogin']);
                }
                if(isset($_GET['timelogout'])){
                    $timelogout = sanitize_text_field($_GET['timelogout']);
                }
                if(isset($_GET['txtsearch'])){
                    $search = sanitize_text_field($_GET['txtsearch']);
                }
                if(isset($_GET['user_role'])){
                    $user_role = sanitize_text_field($_GET['user_role']);
                }
                ualpExportUserLoggedLogCSV($username,$ip,$country,$user_agent,$search,$loginstatus,$timelogin,$timelogout);
                exit();
            }
        }
    }
}