<?php
/*
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}

/*
 * Add log for update reservation settings
 */
if (!function_exists('ualpHookSaveReservationSettings')){

    function ualpHookSaveReservationSettings($old_settings,$new_settings) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('all_in_one_reservation',$logHookList)) {
            $action = "updated";
            $post_title = "All in one Reservation";
            $obj_type = "Settings";
            $post_id = "";
            $hook = "save_reservation_settings";
            $description = "$post_title : $obj_type $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddReservationSettingsLogDetail($uactid,$old_settings,$new_settings);
        }
    }
}
//add_action('save_reservation_settings', 'ualpHookSaveReservationSettings',2,20); // new

/*
 * Add log for update reservation status
 */
if (!function_exists('ualpHookUpdateReservationStatus')){
    function ualpHookUpdateReservationStatus($old_settings,$new_settings) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('all_in_one_reservation',$logHookList)) {
            $request_status = $_REQUEST['status'];
            $action = "'".$request_status ."' successfully";
            $obj_type = "All in one Reservation";
            $post_id = $_REQUEST['postId'];
            $post_title = get_the_title($post_id);
            $hook = "wp_ajax_rest_update_reservation_status";
            $description = "$obj_type : $post_title $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddReservationSettingsLogDetail($uactid,$old_settings,$new_settings);
        }
    }
}
add_action('wp_ajax_rest_update_reservation_status', 'ualpHookUpdateReservationStatus',2,20); // new

/*
 * Add log for reset reservation settings
 */
if (!function_exists('ualpHookResetReservationSettings')){

    function ualpHookResetReservationSettings() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('all_in_one_reservation',$logHookList)) {
            $action = "Reset";
            $post_title = "All in one Reservation";
            $obj_type = "Settings";
            $post_id = "";
            $hook = "reset_reservation_settings";
            $description = "$post_title : $action $obj_type";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('reset_reservation_settings', 'ualpHookResetReservationSettings'); // new

/*
 * Add log for security settings
 */
if (!function_exists('ualpHookReservationSecuritySettings')){

    function ualpHookReservationSecuritySettings($option,$oldvalue,$newvalue) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('all_in_one_reservation',$logHookList)) {
            if($option == 'rest_settings'){
                $action = "Updated";
                $post_title = "All in one Reservation";
                $obj_type = "Settings";
                $post_id = "";
                $hook = "updated_option";
                $description = "$post_title : $obj_type $action";
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                ualpAddWordPressSettingsLogDetail($uactid,$oldvalue,$newvalue,$obj_type,$option);
            }
        }

    }
}
add_action('updated_option', 'ualpHookReservationSecuritySettings',50,3); // new
