<?php

/*
 * fires after autoptimize options updated
 */
if(!function_exists('ualpHookAutoptimizerDeleteCache')) {
    function ualpHookAutoptimizerDeleteCache() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('autoptimizer_settings',$logHookList)) {
            $action = "deleted";
            $obj_type = "Autoptimizer Settings";
            $post_id = "";
            $post_title = 'Cache';
            $hook = "wp_ajax_autoptimize_delete_cache";
            $description = "$obj_type $post_title $action successfully";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_autoptimize_delete_cache','ualpHookAutoptimizerDeleteCache');

/*
 * fires after autoptimize options updated
 */
if(!function_exists('ualpHookAutoptimizerUpdateOptions')) {
    function ualpHookAutoptimizerUpdateOptions($option, $oldvalue, $newvalue) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('autoptimizer_settings',$logHookList)) {
            $whitelisted_options = ualpGetAutoptimizerOptions();
            if (!in_array($option, $whitelisted_options)){
                return;
            }
            $action = "updated";
            $obj_type = "Autoptimizer Settings";
            $post_id = "";
            $post_title = $option;
            $hook = "updated_option";
            $description = "$obj_type $action : $post_title";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddWordPressSettingsLogDetail($uactid,$oldvalue,$newvalue,$obj_type,$option);
        }
    }
}
add_action('updated_option','ualpHookAutoptimizerUpdateOptions',25,3);

if(!function_exists('ualpGetAutoptimizerOptions')) {
    function ualpGetAutoptimizerOptions() {
        $whitelisted_options = apply_filters('ualpGetAutoptimizerOptions', array(
            'autoptimize_html',
            'autoptimize_html_keepcomments',
            'autoptimize_js',
            'autoptimize_js_exclude',
            'autoptimize_js_trycatch',
            'autoptimize_js_justhead',
            'autoptimize_js_forcehead',
            'autoptimize_js_include_inline',
            'autoptimize_css',
            'autoptimize_css_exclude',
            'autoptimize_css_justhead',
            'autoptimize_css_datauris',
            'autoptimize_css_defer',
            'autoptimize_css_defer_inline',
            'autoptimize_css_inline',
            'autoptimize_css_include_inline',
            'autoptimize_cdn_url',
            'autoptimize_cache_clean',
            'autoptimize_cache_nogzip',
            'autoptimize_show_adv',
            'autoptimize_optimize_logged',
            'autoptimize_optimize_checkout',
            'autoptimize_extra_settings'
        ));
        return $whitelisted_options;
    }
}