<?php
/*
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}


/**
 * Get activity for wpcf7 Create
 *
 * @param int $cf7
 */
if (!function_exists('ualpHookwpcf7Create')) {

    function ualpHookwpcf7Create($cf7) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wpcf7_after_create',$logHookList)) {
            $action = "Form Created";
            $obj_type = "Contact Form 7";
            $post_id = "";
            $cf7 = current((Array) $cf7);
            $cf7 = get_the_title($cf7);
            $post_title = $cf7;
            $hook = "wpcf7_after_create";
            $description = "$obj_type : '$post_title' $action";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }

}

add_action('wpcf7_after_create', 'ualpHookwpcf7Create', 10, 1); // new

/**
 * Get activity for wpcf7 Update
 *
 * @param int $cf7
 */
if (!function_exists('ualpHookwpcf7Update')) {

    function ualpHookwpcf7Update($cf7) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wpcf7_after_update',$logHookList)) {
            $action = "Form Updated";
            $obj_type = "Contact Form 7";
            $post_id = "";
            $cf7 = current((Array) $cf7);
            $cf7 = get_the_title($cf7);
            $post_title = $cf7;
            $hook = "wpcf7_after_update";
             $description = "$obj_type : '$post_title' $action";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }

}
add_action('wpcf7_after_update', 'ualpHookwpcf7Update', 10, 1); // new

/**
 * Get activity for wpcf7 Delete
 */
if (!function_exists('ualpHookwpcf7Delete')) {

    function ualpHookwpcf7Delete() {
        if (empty($_REQUEST['message'])) {
            return;
        }
        $logHookList = get_option('enableLogHookList');
        if (in_array('wpcf7_admin_notices',$logHookList)) {
            if ('deleted' == $_REQUEST['message']) {
                $action = "Form Deleted";
                $obj_type = "Contact Form 7";
                $post_id = "";
                $post_title = $obj_type;
                $hook = "wpcf7_admin_notices";
                 $description = "$obj_type : $post_title $action";
                ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        }
    }

}
add_action('wpcf7_admin_notices', 'ualpHookwpcf7Delete'); // new

/*
 * Fires when contact form 7 integration updated
 *
 * @paramn string $action Action Name
 */
if (!function_exists('ualpHookContactForm7Settings')){

    function ualpHookContactForm7Settings($action) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('wpcf7-recaptcha-setup',$logHookList)) {
            if($action == 'wpcf7-recaptcha-setup'){
                $post_title = "Recaptcha Settings Updated";
                $obj_type = "Contact Form 7";
                $post_id = "";
                $hook = "check_admin_referer";
                $description = "$obj_type : $post_title";
                ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        }
    }
}

add_action('check_admin_referer', 'ualpHookContactForm7Settings', 10);
