<?php
/*
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}

/*
 * Add log for one click installation
 */
if (!function_exists('ualpHookOneClickInstall')){

    function ualpHookOneClickInstall() {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "One Click Installation completed successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "import_sample_portfolio_data";
            $description = "$obj_type : $post_title $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $update_info = array(
                'title' =>  $post_title,
                'action'=>  $action
            );
            ualpAddActivityLogDetail($uactid,$update_info);
        }
    }
}
add_action('import_sample_portfolio_data', 'ualpHookOneClickInstall',1,20); // new

/*
 * Add log for create portfolio layout
 */
if (!function_exists('ualpHookCreatePortfolioLayout')){

    function ualpHookCreatePortfolioLayout($layout_id,$layout_name) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Layout created successfully";
            $post_title = $layout_name;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "create_portfolio_layout";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $update_info = array(
                'title' =>  $post_title,
                'action'=>  $action
            );
            ualpAddActivityLogDetail($uactid,$update_info);
        }
    }
}
add_action('create_portfolio_layout', 'ualpHookCreatePortfolioLayout',2,20);

/*
 * Add log for duplicate portfolio layout
 */
if (!function_exists('ualpHookDuplicatePortfolioLayout')){

    function ualpHookDuplicatePortfolioLayout($layout) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Layout duplicated successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "duplicate_portfolio_layout";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('duplicate_portfolio_layout', 'ualpHookDuplicatePortfolioLayout',1,20);

/*
 * Add log for delete portfolio layout
 */
if (!function_exists('ualpHookDeletePortfolioLayout')){

    function ualpHookDeletePortfolioLayout($layout) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Layout deleted successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "delete_portfolio_layout";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('delete_portfolio_layout', 'ualpHookDeletePortfolioLayout',1,20);

/*
 * Add log for update portfolio layout
 */
if (!function_exists('ualpHookUpdatePortfolioLayout')){

    function ualpHookUpdatePortfolioLayout($id,$layout) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Layout updated successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "update_portfolio_layout";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $update_info = array(
                'title' =>  $post_title,
                'action'=>  $action
            );
            ualpAddActivityLogDetail($uactid,$update_info);
        }
    }
}
add_action('update_portfolio_layout', 'ualpHookUpdatePortfolioLayout',2,20);

/*
 * Add log for reset portfolio layout
 */
if (!function_exists('ualpHookResetPortfolioLayout')){

    function ualpHookResetPortfolioLayout($id,$layout) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Layout reset successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "reset_portfolio_layout";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('reset_portfolio_layout', 'ualpHookResetPortfolioLayout',2,20);

/*
 * Add log for import portfolio layout
 */
if (!function_exists('ualpHookImportPortfolioData')){

    function ualpHookImportPortfolioData($layout) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Layout Imported Successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "import_portfolio_layout";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('import_portfolio_layout', 'ualpHookImportPortfolioData',1,20);

/*
 * Add log for export portfolio layout
 */
if (!function_exists('ualpHookExportPortfolioLayout')){

    function ualpHookExportPortfolioLayout($layout) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Layout exported successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "export_portfolio_layout";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('export_portfolio_layout', 'ualpHookExportPortfolioLayout',1,20);

/*
 * Add log for create custom post type
 */
if (!function_exists('ualpHookCreatePostType')){

    function ualpHookCreatePostType($layout) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Post type created successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "create_post_type";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $update_info = array(
                'title' =>  $post_title,
                'action'=>  $action
            );
            ualpAddActivityLogDetail($uactid,$update_info);
        }
    }
}
add_action('create_post_type', 'ualpHookCreatePostType',1,20);


/*
 * Add log for update custom post type
 */
if (!function_exists('ualpHookPostTypeUpdated')){

    function ualpHookPostTypeUpdated($id) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Post type updated successfully";
            $obj_type = "Portfolio Designer";
            $post_id = $id;
            $post_title = $post_id;
            $hook = "update_post_type";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $update_info = array(
                'title' =>  $post_title,
                'action'=>  $action
            );
            ualpAddActivityLogDetail($uactid,$update_info);
        }
    }
}
add_action('update_post_type', 'ualpHookPostTypeUpdated',1,20);


/*
 * Add log for delete custom post type
 */
if (!function_exists('ualpHookDeletePostType')){

    function ualpHookDeletePostType($layout) {

        $logHookList = get_option('enableLogHookList');
        if (in_array('portfolio_designer',$logHookList)) {
            $action = "Post type deleted successfully";
            $post_title = $layout;
            $obj_type = "Portfolio Designer";
            $post_id = "";
            $hook = "delete_post_type";
            $description = "$obj_type : '".ucfirst($post_title)."' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $update_info = array(
                'title' =>  $post_title,
                'action'=>  $action
            );
            ualpAddActivityLogDetail($uactid,$update_info);
        }
    }
}
add_action('delete_post_type', 'ualpHookDeletePostType',1,20);