<?php
/*
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}


/*
 * Add log for export user activities log
 */
if (!function_exists('ualpHookUalpExportLog')){

    function ualpHookUalpExportLog() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_export_activity_log',$logHookList)) {
            $action = "Export";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Export Activity Log";
            $hook = "ualp_export_activity_log";
            $description = "$obj_type : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_export_activity_log', 'ualpHookUalpExportLog'); // new

/*
 * Add log for general settings
 */
if (!function_exists('ualpHookUalpGeneralSettings')){

    function ualpHookUalpGeneralSettings() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_general_settings_updated',$logHookList)) {
            $action = "Settings";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "General Settings";
            $hook = "ualp_general_settings_updated";
            $description = "$obj_type : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_general_settings_updated', 'ualpHookUalpGeneralSettings'); // new

/*
 * Add log for hook settings
 */
if (!function_exists('ualpHookUalpLogHookSettings')){

    function ualpHookUalpLogHookSettings() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_hook_log_settings_updated',$logHookList)) {
            $action = "Settings";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Log Hook Settings";
            $hook = "ualp_hook_log_settings_updated";
            $description = "$obj_type : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_hook_log_settings_updated', 'ualpHookUalpLogHookSettings'); // new

/*
 * Add log for hook settings
 */
if (!function_exists('ualpHookUalpRoleSettings')){

    function ualpHookUalpRoleSettings() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_manage_role',$logHookList)) {
            $action = "Settings";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Role settings updated";
            $hook = "ualp_manage_role";
            $description = "$obj_type : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_manage_role', 'ualpHookUalpRoleSettings'); // new

/*
 * Add log for set password
 */
if (!function_exists('ualpHookUalpPasswordSet')){

    function ualpHookUalpPasswordSet() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_set_password',$logHookList)) {
            $action = "Settings";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Password Set";
            $hook = "ualp_set_password";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_set_password', 'ualpHookUalpPasswordSet'); // new

/*
 * Add log for change password
 */
if (!function_exists('ualpHookUalpPasswordChange')){

    function ualpHookUalpPasswordChange() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_change_password',$logHookList)) {
            $action = "Settings";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Password Updated";
            $hook = "ualp_change_password";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_change_password', 'ualpHookUalpPasswordChange'); // new

/*
 * Add log for email settings update
 */
if (!function_exists('ualpHookEmailSettingsUpdated')){

    function ualpHookEmailSettingsUpdated() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_email_settings_updated',$logHookList)) {
            $action = "Settings";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Email Settings Updated";
            $hook = "ualp_email_settings_updated";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_email_settings_updated', 'ualpHookEmailSettingsUpdated'); // new

/*
 * Add log for disable email notification
 */
if (!function_exists('ualpHookDisableEmail')){

    function ualpHookDisableEmail() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_disable_email_notification',$logHookList)) {
            $action = "Settings";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Disable Email Notification";
            $hook = "ualp_disable_email_notification";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_disable_email_notification', 'ualpHookDisableEmail'); // new

/*
 * Add log for update custom event
 */
if (!function_exists('ualpHookUalpCustomEvent')){

    function ualpHookUalpCustomEvent() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_custom_event_log_updated',$logHookList)) {
            $action = "Settings Updated";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Custom Event Updated";
            $hook = "ualp_custom_event_log_updated";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('ualp_custom_event_log_updated', 'ualpHookUalpCustomEvent'); // new


/*
 * Add log for disable user's activity tracking
 */
if (!function_exists('ualpHookDisableUserTracking')) {

    function ualpHookDisableUserTracking() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('ualp_untrack_users_list_updated', $logHookList)) {
            $action = "Settings";
            $obj_type = "User Activity Log";
            $post_id = "";
            $post_title = "Disable selected users activity tracking";
            $hook = "ualp_untrack_users_list_updated";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }

}
add_action('ualp_untrack_users_list_updated', 'ualpHookDisableUserTracking'); // new