<?php

/*
 * Fires when a user switches to another user account.
 */
if(!function_exists('ualpHookSwitchToUser')) {
    function ualpHookSwitchToUser($user_id, $old_user_id) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_switching',$logHookList)) {
            $user_info = get_userdata($user_id);
            $user_name = isset($user_info->display_name) ? $user_info->display_name : '';
            $old_user_info = get_userdata($old_user_id);
            $old_user_name = isset($old_user_info->display_name) ? $old_user_info->display_name : '';
            $obj_type = 'User Switching';
            $action = 'Switched to';
            $post_id = '';
            $post_title = '';
            $hook = 'switch_to_user';
            $description = "$obj_type : '".ucfirst($old_user_name)."' $action '". ucfirst($user_name)."'";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('switch_to_user','ualpHookSwitchToUser',15,2);

/*
 * Fires when a user switches back to their originating account.
 */
if(!function_exists('ualpHookSwitchBackUser')) {
    function ualpHookSwitchBackUser($user_id, $old_user_id) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_switching',$logHookList)) {
            $user_info = get_userdata($user_id);
            $user_name = isset($user_info->display_name) ? $user_info->display_name : '';
            $old_user_info = get_userdata($old_user_id);
            $old_user_name = isset($old_user_info->display_name) ? $old_user_info->display_name : '';
            $obj_type = 'User Switching';
            $action = 'Switched back to';
            $post_id = '';
            $post_title = '';
            $hook = 'switch_back_user';
            $description = "$obj_type : '".ucfirst($old_user_name)."' $action '". ucfirst($user_name)."'";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('switch_back_user','ualpHookSwitchBackUser',15,2);

/*
 * Fires when a user switches off
 */
if(!function_exists('ualpHookSwitchOffUser')) {
    function ualpHookSwitchOffUser($old_user_id) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_switching',$logHookList)) {
            $old_user_info = get_userdata($old_user_id);
            $old_user_name = isset($old_user_info->display_name) ? $old_user_info->display_name : '';
            $obj_type = 'User Switching';
            $action = 'Switched off user';
            $post_id = '';
            $post_title = $old_user_id;
            $hook = 'switch_off_user';
            $description = "$obj_type : '".ucfirst($old_user_name)."' $action '";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('switch_off_user','ualpHookSwitchOffUser',15,1);