<?php

/*
 * fires when custom profile field created
 */
if(!function_exists('ualpHookAddNewCustomProfileField')) {
    function ualpHookAddNewCustomProfileField() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Custom Profile field created.';
            $post_id = '';
            $post_title = '';
            $hook = 'wp_ajax_add_new_custom_profile_field';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_add_new_custom_profile_field','ualpHookAddNewCustomProfileField');

/*
 * fires when profile fields saved
 */
if(!function_exists('ualpHookSaveFieldsSettings')) {
    function ualpHookSaveFieldsSettings() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Profile field updated successfully.';
            $post_id = '';
            $post_title = '';
            $hook = 'wp_ajax_save_fields_settings';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_save_fields_settings','ualpHookSaveFieldsSettings');

/*
 * fires when profile field deleted
 */
if(!function_exists('ualpHookDeleteProfileField')) {
    function ualpHookDeleteProfileField() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Profile field deleted successfully.';
            $post_id = '';
            $post_title = '';
            $hook = 'wp_ajax_delete_profile_field';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_delete_profile_field','ualpHookDeleteProfileField');

/*
 * fires when fields sorted
 */
if(!function_exists('ualpHookSortFiledsList')) {
    function ualpHookSortFiledsList() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Fields order updated successfully.';
            $post_id = '';
            $post_title = '';
            $hook = 'wp_ajax_sort_fileds_list';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_sort_fileds_list','ualpHookSortFiledsList');

/*
 * fires when custom fields reset
 */
if(!function_exists('ualpHookCustomFieldsReset')) {
    function ualpHookCustomFieldsReset() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Custom Profile fields reseted successfully.';
            $post_id = '';
            $post_title = '';
            $hook = 'wp_ajax_custom_fields_reset';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_custom_fields_reset','ualpHookCustomFieldsReset');

/*
 * fires when uploader folder created
 */
if(!function_exists('ualpHookCreateUploaderFolder')) {
    function ualpHookCreateUploaderFolder() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Uploader folder created.';
            $post_id = '';
            $post_title = '';
            $hook = 'wp_ajax_create_uploader_folder';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_create_uploader_folder','ualpHookCreateUploaderFolder');

/*
 * fires when settings updated
 */
if(!function_exists('ualpHookUserUltraSettings')) {
    function ualpHookUserUltraSettings($option,$oldvalue,$newvalue) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $whitelisted_options = ualpGetUserUltraOptions();
            if (!in_array($option, $whitelisted_options)){
                return;
            }
            $obj_type = 'User Ultra Membership';
            $action = 'Settings updated';
            $post_id = '';
            $post_title = $option;
            $hook = 'updated_option';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddWordPressSettingsLogDetail($uactid,$oldvalue,$newvalue,$obj_type,$option);
        }
    }
}
add_action('updated_option','ualpHookUserUltraSettings',50,3);


if(!function_exists('ualpGetUserUltraOptions')) {
    function ualpGetUserUltraOptions() {
        $whitelisted_options = apply_filters('ualpGetUserUltraOptions', array(
            'xoousersultra_my_account_page',
            'xoousersultra_auto_page_creation',
            'xoousersultra_already_rated_ultra',
            'xoousersultra_pro_annuncement_1463',
            'xoousersultra_auto_page_creation',
            'xoousersultra_custom_css',
            'userultra_options',
            'userultra',
            'userultra_default_user_tabs',
            'uultra_cached_results',
            'get_twitter_auth_url'
        ));
        return $whitelisted_options;
    }
}

/*
 * fires when membership Package created
 */
if(!function_exists('ualpHookPackageAddNew')) {
    function ualpHookPackageAddNew() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Membership Package created successfully.';
            $post_id = '';
            $post_title = (isset($_POST['p_name']) && $_POST['p_name'] != '') ? sanitize_text_field($_POST['p_name']) : '';
            $hook = 'wp_ajax_package_add_new';
            $description = "$obj_type : '$post_title' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_package_add_new','ualpHookPackageAddNew');

/*
 * fires when membership Package deleted
 */
if(!function_exists('ualpHookPackageDelete')) {
    function ualpHookPackageDelete() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Membership Package deleted successfully.';
            $post_id = (isset($_POST["p_id"]) && $_POST["p_id"] != '') ? $_POST["p_id"] : '';
            $package = XooPaypalPayment::get_package($post_id);
            $post_title = $package->package_name;
            $hook = 'wp_ajax_package_delete';
            $description = "$obj_type : '$post_title' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_package_delete','ualpHookPackageDelete');

/*
 * fires when membership Package updated
 */
if(!function_exists('ualpHookPackageEditConfirm')) {
    function ualpHookPackageEditConfirm() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Membership Package updated successfully.';
            $post_id = '';
            $post_title = (isset($_POST['p_name']) && $_POST['p_name'] != '') ? sanitize_text_field($_POST['p_name']) : '';
            $hook = 'wp_ajax_package_edit_confirm';
            $description = "$obj_type : '$post_title' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_package_edit_confirm','ualpHookPackageEditConfirm');

/*
 * fires when sync users
 */
if(!function_exists('ualpHookSyncUsers')) {
    function ualpHookSyncUsers() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Sync users';
            $post_id = '';
            $post_title = '';
            $hook = 'wp_ajax_sync_users';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_sync_users','ualpHookSyncUsers');

/*
 * fires when resend Activation Link
 */
if(!function_exists('ualpHookUserResendActivationLink')) {
    function ualpHookUserResendActivationLink() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Resend Activation Link';
            $post_id = '';
            $post_title = '';
            $hook = 'wp_ajax_user_resend_activation_link';
            $description = "$obj_type : $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_user_resend_activation_link','ualpHookUserResendActivationLink');



/*
 * fires when Delete Users Ultra Transients
 */
if(!function_exists('ualpHookDeleteUultraTranstient')) {
    function ualpHookDeleteUultraTranstient() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $post_title = 'Users Ultra Transients';
            $post_id = '';
            $action = 'Deleted';
            $hook = 'wp_ajax_delete_uultra_transtient';
            $description = "$obj_type : $post_title $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_delete_uultra_transtient','ualpHookDeleteUultraTranstient');


/*
 * fires when Clean the Users Ultra Stats
 */
if(!function_exists('ualpHookDeleteUultraStats')) {
    function ualpHookDeleteUultraStats() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Clean';
            $post_id = '';
            $post_title = 'Users Ultra Stats';
            $hook = 'wp_ajax_delete_uultra_stats';
            $description = "$obj_type : $action $post_title";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_delete_uultra_stats','ualpHookDeleteUultraStats');


/*
 * fires when Clean the Users Ultra Ratings
 */
if(!function_exists('ualpHookDeleteUultraReviews')) {
    function ualpHookDeleteUultraReviews() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $obj_type = 'User Ultra Membership';
            $action = 'Clean';
            $post_id = '';
            $post_title = 'Users Ultra Ratings';
            $hook = 'wp_ajax_delete_uultra_reviews';
            $description = "$obj_type : $action $post_title";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_delete_uultra_reviews','ualpHookDeleteUultraReviews');

/*
 * Fires when update photo category
 */
if(!function_exists('ualpHookConfPhotoCate')) {
    function ualpHookConfPhotoCate() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            if ($cate_id != "" && $cate_name != "") {
                $cate_id = $_POST["cate_id"];
                $cate_name = $_POST["cate_name"];
                $obj_type = 'User Ultra Membership';
                $post_title = $cate_name;
                $post_id = $cate_id;
                $action = 'Photo category updated successfully';
                $hook = 'wp_ajax_edit_photo_cate_conf';
                $description = "$obj_type : '$post_title' $action";
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        }
    }
}
add_action( 'wp_ajax_edit_photo_cate_conf', 'ualpHookConfPhotoCate' );

/*
 * fires when delete photo category
 */
if(!function_exists('ualpHookPhotoCateDelete')) {
    function ualpHookPhotoCateDelete() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            global $wpdb;
            $cate_id = $_POST["cate_id"];
            $photo_cat_name = $wpdb->get_var("select photo_cat_name from " . $wpdb->prefix . "usersultra_photo_categories WHERE `photo_cat_id` = '" . (int) $cate_id . "'  ");
            $obj_type = 'User Ultra Membership';
            $post_title = $photo_cat_name;
            $post_id = $cate_id;
            $action = 'Photo category deleted successfully';
            $hook = 'wp_ajax_edit_photo_cate_del';
            $description = "$obj_type : '$post_title' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action( 'wp_ajax_edit_photo_cate_del', 'ualpHookPhotoCateDelete' );

/*
 * fires when edit photo category
 */
if(!function_exists('ualpHookEditPhotoCate')) {
    function ualpHookEditPhotoCate() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            global $wpdb;
            $cate_id = $_POST["cate_id"];
            $photo_cat_name = $wpdb->get_var("select photo_cat_name from " . $wpdb->prefix . "usersultra_photo_categories WHERE `photo_cat_id` = '" . (int) $cate_id . "'  ");
            $obj_type = 'User Ultra Membership';
            $post_title = $photo_cat_name;
            $post_id = $cate_id;
            $action = 'Photo category edited successfully';
            $hook = 'wp_ajax_edit_photo_cate';
            $description = "$obj_type : '$post_title' $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action( 'wp_ajax_edit_photo_cate', 'ualpHookEditPhotoCate' );

/*
 * fires when create photo category
 */
if(!function_exists('ualpHookAddPhotocategory')) {
    function ualpHookAddPhotocategory() {
        $logHookList = get_option('enableLogHookList');
        if(isset($_GET['page']) && $_GET['page'] == 'uultra-photocategory' && in_array('user_ultra_settings',$logHookList)){
            if(isset($_POST['submit']) && isset($_POST['add-category']) && $_POST['add-category'] == 'add-cate'){
                if (isset($_POST['photo_cat_name'])) {
                    $photo_cat_name = $_POST['photo_cat_name'];
                    $new_array = array(
                        'photo_cat_id' => null,
                        'photo_cat_name' => $photo_cat_name
                    );
                    $obj_type = 'User Ultra Membership';
                    $post_title = $photo_cat_name;
                    $post_id = '';
                    $action = 'Photo category created successfully';
                    $hook = 'userultra_admin_menu_hook';
                    $description = "$obj_type : '$post_title' $action";
                    $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                }
            }
        }
    }
}

add_action( 'admin_init', 'ualpHookAddPhotocategory' );

/*
 * fires when Auto sync with woocommerce
 */
if(!function_exists('ualpHookSyncKeepExistingField')) {
    function ualpHookSyncKeepExistingField() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            global $pagenow;
            $tab  = isset($_GET['tab']) ? $_GET['tab'] : '';
            if('admin.php' == $pagenow && isset($_GET['page']) && ('import' == $tab) && in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ){
                if ( (isset($_REQUEST['sync']) && $_REQUEST['sync'] == 'woocommerce' ) && !isset($_POST['submit']) && !isset($_POST['uultra-add']) && !isset($_POST['reset-options']) && !isset($_POST['reset-options-fields']) ) {
                    $obj_type = 'User Ultra Membership';
                    $post_title = 'Sync and keep existing fields.';
                    $post_id = '';
                    $action = 'Auto sync with woocommerce';
                    $hook = 'init';
                    $description = "$obj_type : $action - $post_title";
                    $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                }
            }
        }
    }
}

add_action( 'init', 'ualpHookSyncKeepExistingField' );

/*
 * Fires when Auto sync with woocommerce
 */
if(!function_exists('ualpHookSyncDeleteExistingField')) {
    function ualpHookSyncDeleteExistingField() {
        global $pagenow;
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $tab  = isset($_GET['tab']) ? $_GET['tab'] : '';
            if('admin.php' == $pagenow && isset($_GET['page']) && ('import' == $tab) && in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ){
                if ( (isset($_REQUEST['sync']) && $_REQUEST['sync'] == 'woocommerce_clean' ) && !isset($_POST['submit']) && !isset($_POST['uultra-add']) && !isset($_POST['reset-options']) && !isset($_POST['reset-options-fields']) ) {
                    $obj_type = 'User Ultra Membership';
                    $post_title = 'Sync and delete existing fields.';
                    $post_id = '';
                    $action = 'Auto sync with woocommerce';
                    $hook = 'init';
                    $description = "$obj_type : $action - $post_title";
                    $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                }
            }
        }
    }
}

add_action( 'init', 'ualpHookSyncDeleteExistingField' );


/*
 * Fires when Auto sync with woocommerce
 */
if(!function_exists('ualpHookImportUser')) {
    function ualpHookImportUser() {
        global $pagenow;
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_ultra_settings',$logHookList)) {
            $tab  = isset($_GET['tab']) ? $_GET['tab'] : '';
            if('admin.php' == $pagenow && isset($_GET['page']) && ('import' == $tab)){
                if (isset($_POST['uultra-form-cvs-form-conf'])){
                    $obj_type = 'User Ultra Membership';
                    $post_title = 'Users Imported successfully';
                    $post_id = '';
                    $action = 'Import';
                    $hook = 'init';
                    if(isset($_POST["uultra-send-welcome-email"] ) && $_POST["uultra-send-welcome-email"] == 1) {
                        $post_title .= " and Send Welcome Email";
                    }
                    if(isset($_POST["uultra-activate-account"]) && $_POST["uultra-activate-account"] != '') {
                        if($_POST["uultra-activate-account"] == 'active'){
                            $post_title .= " and Activate account automatically.";
                        } elseif($_POST["uultra-activate-account"] == 'pending') {
                            $post_title .= " and Send Activation Link.";
                        }
                    }
                    $description = "$obj_type : $post_title";
                    $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
		}
            }
        }
    }
}

add_action( 'init', 'ualpHookImportUser' );