<?php
/*
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}

/*
 * Add log for update reservation settings
 */
if (!function_exists('ualpHookSaveWCFESettings')){

    function ualpHookSaveWCFESettings($old_settings,$new_settings) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wc_checkout_fields_editor',$logHookList)) {
            $action = "updated successfully";
            $post_title = "WC checkout fields editor";
            $obj_type = "Settings";
            $post_id = "";
            $hook = "save_wcfe_settings";
            $description = "$post_title : $obj_type $action";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddReservationSettingsLogDetail($uactid,$old_settings,$new_settings);
        }
    }
}
add_action('save_wcfe_settings', 'ualpHookSaveWCFESettings',20,2); // new

/*
 * Add log for reset reservation settings
 */
if (!function_exists('ualpHookResetWCFESettings')){
    function ualpHookResetWCFESettings() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wc_checkout_fields_editor',$logHookList)) {
            $action = "Default settings restored";
            $post_title = "WC checkout fields editor";
            $obj_type = "settings";
            $post_id = "";
            $hook = "wp_ajax_wcfe_get_checkout_required_fields";
            $description = "$post_title : $action $obj_type";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_ajax_wcfe_get_checkout_required_fields', 'ualpHookResetWCFESettings',50); // new
