<?php

/*
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}

$old_user_meta = '';
/*
 * Insert record into wp_user_activity table
 *
 * @param int $post_id Post ID.
 * @param string $post_title Post Title.
 * @param string $obj_type Object Type (Plugin, Post, User etc.).
 * @param int $current_user_id current user id.
 * @param string $current_user current user name.
 * @param string $user_role current user Role.
 * @param string $user_mail current user Email address.
 * @param datetime $modified_date current user's modified time.
 * @param string $ip current user's IP address.
 * @param string $action current user's activity name.
 *
 */
if (!function_exists('ualpInsertLog')) {

    function ualpInsertLog($post_id, $post_title, $obj_type, $current_user_name, $action, $hook, $description) {
        global $wpdb, $externaldb;
        $post_title = addslashes($post_title);
        $modified_date = current_time('mysql');
        $ips = $_SERVER['REMOTE_ADDR'];
        $user_agents = $_SERVER['HTTP_USER_AGENT'];
        $ip = '';
        $user_agent = '';
        if(ualpAllowIp()) {
            $ip = $ips;
        }
        $username = get_user_by('login', $current_user_name);
        $guest_disable = $user_mail = $current_user_id = $user_role = '';
        if(isset($username) && !empty($username)) {
            $current_user_name = $username->data->display_name;
            $user_mail = $username->data->user_email;
            $current_user_id = $username->data->ID;
            if (!empty($username->roles) && is_array($username->roles)) {
                if(sizeof($username->roles) == 1){
                    $user_role = $username->roles[0];
                } else {
                    $userRole = $username->roles;
                    foreach($userRole as $all_rols){
                        $user_role .= $all_rols.' ,';
                    }
                }
            }
        }else {
            $current_user_name = "Guest";
            $user_mail = "";
            $current_user_id = "";
            $user_role = "";
            $guest_disable = get_option('ualp_untrack_guest_users');
        }
        ualpCreateTable();
        ualpCreateDetailTable();
        ualpCreateExternalTable();
        ualpCreateDetailExternalTable();
        /**
         * ualpBeforeInsertLog hook.
         */
        do_action('ualpBeforeInsertLog');
        $user_disable = $disable_user_list = array();
        $disable_user_list = get_option('ualp_untrack_users_list');
        $user_disable = (isset($disable_user_list) && $disable_user_list != '') ? $disable_user_list : array();
        $country = '';
        if(ualpAllowCountry()) {
            $country = (isset($ips) && ($ips != '')) ? ualpIpInfo($ips, "country") : '';
        }
        if(ualpAllowUserAgent()) {
            $user_agent = $user_agents;
            $user_agent = str_replace(';', ',', $user_agent);
        }

        if(is_user_logged_in()){
            if(is_array($user_disable) && !in_array($username->ID, $user_disable)) {
                $t_session = wp_get_session_token();
                $insert_query = $externaldb->insert(
                    UALP_TABLENAME,
                        array(
                            'post_id' => $post_id,
                            'favorite' => '0',
                            'post_title' => $post_title,
                            'user_id' => $current_user_id,
                            'user_name' => $current_user_name,
                            'user_role' => $user_role,
                            'user_email' => $user_mail,
                            'ip_address' => $ip,
                            'country' => $country,
                            'user_agent' => $user_agent,
                            'modified_date' => $modified_date,
                            'object_type' => $obj_type,
                            'action' => $action,
                            'hook' => $hook,
                            'description' => $description,
                            't_session' => $t_session
                        )
                );
            }
        } else {
            if($guest_disable == '1') {
                return;
            }
            $insert_query = $externaldb->insert(
                UALP_TABLENAME,
                array(
                    'post_id' => $post_id,
                    'favorite' => '0',
                    'post_title' => $post_title,
                    'user_id' => $current_user_id,
                    'user_name' => $current_user_name,
                    'user_role' => $user_role,
                    'user_email' => $user_mail,
                    'ip_address' => $ip,
                    'country' => $country,
                    'user_agent' => $user_agent,
                    'modified_date' => $modified_date,
                    'object_type' => $obj_type,
                    'action' => $action,
                    'hook' => $hook,
                    'description' => $description,
                    't_session' => ''
                )
            );
        }

        /**
         * ualpAfterInsertLog hook.
         */
        do_action('ualpAfterInsertLog');
        return $externaldb->insert_id;
    }

}

/*
 * Insert record when user login
 */
if (!function_exists('ualpInsertLoginLog')) {

    function ualpInsertLoginLog($logged_in_cookie, $expire, $expiration, $user_id, $logged_in_text, $token) {
        
        global $wpdb, $externaldb;
        $ips = $_SERVER['REMOTE_ADDR'];
        $user_agents = $_SERVER['HTTP_USER_AGENT'];
        $time_login = $time_last_seen = current_time('mysql');
        $ip = '';
        $user_agent = '';
        if(ualpAllowIp()) {
            $ip = $ips;
        }
        $current_user_id = $user_id;
        $username = get_user_by('id', $current_user_id);
        $user_mail = $user_role = '';
        if(isset($username) && !empty($username)) {
            $current_user_name = $username->data->display_name;
            $user_mail = $username->data->user_email;    
            if (!empty($username->roles) && is_array($username->roles)) {
                if(sizeof($username->roles) == 1){
                    $user_role = $username->roles[0];
                } else {
                    $userRole = $username->roles;
                    foreach($userRole as $all_rols){
                        $user_role .= $all_rols.' ,';
                    }
                }
            }
        }
        /**
         * ualpBeforeInsertLog hook.
         */
        do_action('ualpBeforeInsertLoginLog');
        $user_disable = $disable_user_list = array();
        $disable_user_list = get_option('ualp_untrack_users_list');
        $user_disable = (isset($disable_user_list) && $disable_user_list != '') ? $disable_user_list : array();
        $country = '';
        if(ualpAllowCountry()) {
            $country = (isset($ips) && ($ips != '')) ? ualpIpInfo($ips, "country") : '';
        }
        if(ualpAllowUserAgent()) {
            $user_agent = $user_agents;
            $user_agent = str_replace(';', ',', $user_agent);
        }
        if(is_array($user_disable) && !in_array($current_user_id, $user_disable)) {
            $insert_query = $externaldb->insert(
                UALP_LOGIN_TABLENAME,
                    array(
                        'user_id' => $current_user_id,
                        'user_name' => $current_user_name,
                        'user_role' => $user_role,
                        'user_email' => $user_mail,
                        'time_login' => $time_login,
                        'time_last_seen' => $time_last_seen,
                        'session_token' => $token,
                        'ip_address' => $ip,
                        'country' => $country,
                        'user_agent' => $user_agent,
                        'login_status' => 'login',
                    )
            );
        }
        do_action('ualpAfterInsertLoginLog');
    }

}

/*
 * Insert record when user logout
 */
if (!function_exists('ualpInsertLogoutLog')) {

    function ualpInsertLogoutLog() {
        global $wpdb, $externaldb;
        $session_token = wp_get_session_token();
        $time_logout = current_time('mysql');
        /**
         * ualpBeforeInsertLog hook.
         */
        do_action('ualpBeforeInsertLogoutLog');
        $externaldb->update(
                UALP_LOGIN_TABLENAME,
                array( 'time_logout' =>$time_logout,'time_last_seen' => $time_logout,'login_status'=>'logout'  ),
                array( 'session_token' => $session_token )
            );
        do_action('ualpAfterInsertLogoutLog');
    }

}

/*
 * Insert record of user last seen
 */
if (!function_exists('ualpUpdateLastSeen')) {

    function ualpUpdateLastSeen() {
        global $wpdb, $externaldb;
        $session_token = wp_get_session_token();        
        if($session_token != '') {
            $time_last_seen = current_time('mysql');
            $externaldb->update(
                UALP_LOGIN_TABLENAME,
                array('time_last_seen' => $time_last_seen),
                array( 'session_token' => $session_token )
            );
        }
    }

}

/*
 * get activity
 *
 * @param string $action current user's activity name.
 * @param string $obj_type Object Type (Plugin, Post, User etc.).
 * @param int $post_id Post ID.
 * @param string $post_title Post Title.
 * @param string $hook Hook Name.
 * @param string $description Description.
 * @return int $ualpInsertLog Log Id
 *
 */
if (!function_exists('ualpGetActivityLog')) {

    function ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description) {
        $current_user_id = get_current_user_id();
        $current_user = wp_get_current_user();
        $current_user_name = $current_user->user_login;
        $ualpInsertLog = ualpInsertLog($post_id, $post_title, $obj_type, $current_user_name, $action, $hook, $description);
        return $ualpInsertLog;
    }

}

/*
 * Add activity for the current user when login
 *
 * @param string $current_user_name string user's login name.
 * @param string $user_login current user's login name.
 *
 */
if (!function_exists('ualpHookWpLogin')){

    function ualpHookWpLogin($current_user_name) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wp_login',$logHookList)) {
            $action = "logged in";
            $obj_type = "User";
            $post_id = "";
            $username = get_user_by('login', $current_user_name);
            $post_title = $username->display_name;
            $hook = "wp_login";
            $description = "$obj_type $action : $post_title";
            ualpInsertLog($post_id, $post_title, $obj_type, $current_user_name, $action, $hook, $description);
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpUserLoginNotify', $ualpUserEmailNotify)){
                ualpSendEmailNotification($current_user_name,'User logged in successfully');
            }
        }
    }

}
add_action('wp_login', 'ualpHookWpLogin', 9);
add_action('set_logged_in_cookie', 'ualpInsertLoginLog', 9, 6);

/*
 * Get activity for the user - Login fail
 *
 * @param string $current_user_name username
 */
if (!function_exists('ualpHookWpLoginFailed')){

    function ualpHookWpLoginFailed($current_user_name) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wp_login_failed',$logHookList)) {
            $action = "login failed";
            $obj_type = "User";
            $post_id = "";
            $username = get_user_by('login', $current_user_name);
            if(isset($username) && !empty($username)){
                $post_title = $username->display_name;
            }else {
                $post_title = "Guest";
            }
            $hook = "wp_login_failed";
            $description = "$obj_type $action : $post_title";
            ualpInsertLog($post_id, $post_title, $obj_type, $current_user_name, $action, $hook, $description);
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpUserLoginFailNotify', $ualpUserEmailNotify)){
                ualpSendEmailNotification($current_user_name,'User login failed');
            }
        }
    }
}
add_action('wp_login_failed', 'ualpHookWpLoginFailed', 10, 1);


/*
 * Get activity for the current user when logout
 */
if (!function_exists('ualpHookWpLogout')){

    function ualpHookWpLogout() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wp_logout',$logHookList)) {
            $action = "logged out";
            $obj_type = "User";
            $post_id = get_current_user_id();
            if(isset($post_id) && !empty($post_id)){
                $user_nm = wp_get_current_user();
                $current_user_name = $user_nm->data->user_login;
                $post_title = $user_nm->data->display_name;
            }else{
                $current_user_name = "";
                $post_title = "Guest";
            }
            $hook = "wp_logout";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}

add_action('wp_logout', 'ualpHookWpLogout', 8);
add_action('wp_logout', 'ualpInsertLogoutLog', 10);
add_action('init', 'ualpUpdateLastSeen', 10);

/*
 * Get activity for the delete user
 *
 * @param int $user User ID
 *
 */
if (!function_exists('ualpHookDeleteUser')){

    function ualpHookDeleteUser($user) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('delete_user',$logHookList)) {
            $action = "deleted";
            $obj_type = "User";
            $post_id = $user;
            $user_nm = get_user_by('id', $post_id);
            $current_user_name = $user_nm->user_login;
            $post_title = $user_nm->display_name;
            $hook = 'delete_user';
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpUserDeleted', $ualpUserEmailNotify)){
                ualpSendEmailNotification($current_user_name,'User deleted successfully');
            }
        }
    }
}

add_action('delete_user', 'ualpHookDeleteUser', 10, 1);

/*
 * Get activity for the registered user
 *
 * @param int $user User ID
 *
 */
if (!function_exists('ualpHookUserRegister')){

    function ualpHookUserRegister($user) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('user_register',$logHookList)) {
            $action = "registered";
            $obj_type = "User";
            $post_id = $user;
            $user_nm = get_user_by('id', $post_id);
            $current_user_name = $user_nm->user_login;
            $post_title = $user_nm->display_name;
            $hook = "user_register";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpUserRegisterNotify', $ualpUserEmailNotify)){
                ualpSendEmailNotification($current_user_name,'User registered successfully');
            }
        }
    }
}

add_action('user_register', 'ualpHookUserRegister', 10, 1);

/*
 * Get activity for the update user
 *
 * @param object $user
 */
if(!function_exists('ualpPreUserUpdate')) {
    function ualpPreUserUpdate($user) {
        $user_id = $user->data->ID;
        $user_full_key_array = ualpGetUserPrimaryData();
        foreach ($user_full_key_array as $user_key) {
            $old_user_meta[$user_key] = $user->data->$user_key;
        }
        $user_full_metakey_array = ualpGetUserMetaData();
        foreach($user_full_metakey_array as $user_meta_key) {
            $old_user_meta[$user_meta_key] = get_user_meta($user_id, $user_meta_key, true);
        }
        set_transient( 'ualp_old_user_data_' . $user_id, $old_user_meta, 60 * 30 );
    }
}
add_action('show_user_profile','ualpPreUserUpdate');
add_action('edit_user_profile','ualpPreUserUpdate');

/*
 * Get activity for the update user
 *
 * @param int $user_id
 */
if(!function_exists('ualpUserUpdate')) {
    function ualpUserUpdate($user_id) {
        $post_id = $user_id;
        $old_user_data = get_transient('ualp_old_user_data_' . $user_id);
        $new_user_data = array();
        $user = get_userdata($user_id);
        $user_full_key_array = ualpGetUserPrimaryData();
        foreach ($user_full_key_array as $user_key_single=>$user_value_single) {
            if(!is_numeric($user_key_single)) {
                if(isset($_POST[$user_key_single])) {
                    $new_user_data[$user_value_single] = sanitize_text_field($_POST[$user_key_single]);
                }
            }
            else {
                if(isset($_POST[$user_value_single])) {
                    $new_user_data[$user_value_single] = sanitize_text_field($_POST[$user_value_single]);
                }
            }
        }
        $user_full_metakey_array = ualpGetUserMetaData();
        foreach($user_full_metakey_array as $user_meta_key_single=>$user_meta_value_single) {
            $value = '';
            if(!is_numeric($user_meta_key_single)) {
                if($user_meta_key_single == 'rich_editing') {
                    $value = isset($_POST[$user_meta_key_single]) ? 'false' : 'true';
                }
                else if($user_meta_key_single == 'admin_bar_front') {
                    $value = isset($_POST[$user_meta_key_single]) ? 'true' : 'false';
                }
                else if(isset($_POST[$user_meta_key_single])) {
                    $value = sanitize_text_field($_POST[$user_meta_key_single]);
                }
                $new_user_data[$user_meta_value_single] = $value;
            }
            else {
                if($user_meta_value_single == 'rich_editing') {
                    $value = isset($_POST[$user_meta_value_single]) ? 'false' : 'true';
                }
                else if($user_meta_value_single == 'admin_bar_front') {
                    $value = isset($_POST[$user_meta_value_single]) ? 'true' : 'false';
                }
                else if(isset($_POST[$user_meta_value_single])) {
                    $value = sanitize_text_field($_POST[$user_meta_value_single]);
                }
                $new_user_data[$user_meta_value_single] = $value;
            }
        }
        $action = "profile updated";
        $obj_type = "User";
        $current_user_name = $user->user_login;
        $post_title = $user->display_name;
        $hook = "insert_user_meta";
        $description = "$obj_type $action : $post_title";
        $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        delete_transient('ualp_old_user_data_' . $user_id);
        ualpAddActivityLogDetailUserUpdate($uactid, $old_user_data, $new_user_data, $hook);
        $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
        if(is_array($ualpUserEmailNotify) && in_array('ualpUserProfileUpdated', $ualpUserEmailNotify)){
            ualpSendEmailNotification($current_user_name,'User profile updated successfully');
        }
    }
}
add_action('edit_user_profile_update','ualpUserUpdate',5000);
add_action('personal_options_update','ualpUserUpdate',5000);

/**
 * Get activity for the password reset
 *
 * @param object $user
 * @param string $new_pass
 */
if(!function_exists('ualpHookPasswordReset')){

    function ualpHookPasswordReset( $user, $new_pass ) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('password_reset',$logHookList)) {
            $action = "Password Reset";
            $obj_type = "User";
            $post_id = "";
            $post_title = $obj_type;
            $hook = "password_reset";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpUserChangePasswordNotify', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Password Reseted Successfully');
            }
        }
    }
}
add_action( 'password_reset', 'ualpHookPasswordReset', 10, 2 );

/*
 * Get activity for the user - add attach media file
 *
 * @param int $attach Post ID
 *
 */
if (!function_exists('ualpHookAddAttachment')){

    function ualpHookAddAttachment($attach) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('attachment',$logHookList)) {
            $action = "added";
            $obj_type = "Attachment";
            $post_id = $attach;
            $post_title = get_the_title($post_id);
            $hook = "add_attachment";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}

add_action('add_attachment', 'ualpHookAddAttachment');

/*
 * Get activity for the user - edit attach media file
 *
 * @param int $attach Post ID
 *
 */
if (!function_exists('ualpHookEditAttachment')){

    function ualpHookEditAttachment($attach) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('attachment',$logHookList)) {
            $post_id = $attach;
            $post_title = get_the_title($post_id);
            $action = "updated";
            $obj_type = "Attachment";
            $hook = "edit_attachment";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}

add_action('edit_attachment', 'ualpHookEditAttachment');

/*
 * Get activity for the user - delete attach media file
 *
 * @param int $attach Post ID
 *
 */
if (!function_exists('ualpHookDeleteAttachment')){

    function ualpHookDeleteAttachment($attach) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('attachment',$logHookList)) {
            $post_id = $attach;
            $post_title = get_the_title($post_id);
            $action = "deleted";
            $obj_type = "Attachment";
            $hook = "delete_attachment";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}

add_action('delete_attachment', 'ualpHookDeleteAttachment');

/*
 * Get activity for the user - Insert Comment
 *
 * @param int $comment Comment ID
 *
 */
if (!function_exists('ualpHookWpInsertComment')){

    function ualpHookWpInsertComment($comment) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wp_insert_comment',$logHookList)) {
            $action = "inserted";
            $obj_type = "Comment";
            $comment_id = $comment;
            $com = get_comment($comment_id);
            $post_id = $com->comment_post_ID;
            $comment_detail_ary = array();
            $comment_detail_ary['ualp_comment'] = $com->comment_content;
            $comment_detail_ary['ualp_comment_id'] = $comment_id;
            $post_title = get_the_title($post_id);
            $post_link = get_the_permalink($post_id);
            $hook = "wp_insert_comment";
            $description = "$obj_type $action in <a target='blank' href='$post_link'>$post_title</a>";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddActivityLogDetail($uactid,$comment_detail_ary);
        }
    }
}

add_action('wp_insert_comment', 'ualpHookWpInsertComment');

/*
 * Get activity for the user - Edit Comment
 *
 * @param int $comment Comment ID
 *
 */
if (!function_exists('ualpHookEditComment')){

    function ualpHookEditComment($comment) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('edit_comment',$logHookList)) {
            $action = "edited";
            $obj_type = "Comment";
            $comment_id = $comment;
            $com = get_comment($comment_id);
            $post_id = $com->comment_post_ID;
            $comment_detail_ary = array();
            $comment_detail_ary['ualp_comment'] = $com->comment_content;
            $comment_detail_ary['ualp_comment_id'] = $comment_id;
            $post_title = get_the_title($post_id);
            $post_link = get_edit_post_link($post_id);
            if($post_link == ''){
                $post_link = get_the_permalink($post_id);
            }
            $hook = "edit_comment";
            $description = "$obj_type $action in <a target='blank' href='$post_link'>$post_title</a>";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddActivityLogDetail($uactid,$comment_detail_ary);
        }
    }
}

add_action('edit_comment', 'ualpHookEditComment');

/*
 * Get activity for the user - Delete Comment
 *
 * @param int $comment Comment ID
 *
 */
if (!function_exists('ualpHookDeleteComment')){

    function ualpHookDeleteComment($comment) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('delete_comment',$logHookList)) {
            $action = "deleted";
            $obj_type = "Comment";
            $com = get_comment($comment);
            $post_id = $com->comment_post_ID;
            $comment_detail_ary = array();
            $comment_detail_ary['ualp_comment_id'] = $comment;
            $comment_detail_ary['ualp_comment'] = $com->comment_content;
            $post_title = get_the_title($post_id);
            $post_link = get_the_permalink($post_id);
            $hook = "delete_comment";
            $description = "$obj_type $action from <a target='blank' href='$post_link'>$post_title</a>";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddActivityLogDetail($uactid,$comment_detail_ary);
        }
    }
}

add_action('delete_comment', 'ualpHookDeleteComment',10,1);

/*
 * Get activity for the user - Comment status change
 *
 * @param string $new_status New status of comment
 * @param string $old_status Old status of comment
 * @param int $comment_id Comment ID
 *
 */
if (!function_exists('ualpHookStatusComment')){

    function ualpHookStatusComment($new_status, $old_status, $comment_id) {
        $logHookList = get_option('enableLogHookList');
        $obj_type = "Comment";
        $com = get_comment($comment_id);
        $post_id = $com->comment_post_ID;
        $comment_detail_ary = array();
        $comment_detail_ary['ualp_comment'] = $com->comment_content;
        $post_title = get_the_title($post_id);
        $post_link = get_the_permalink($post_id);
        if($new_status == 'approved') {
            if($old_status == 'trash' || $old_status == 'spam') {
                $action = 'restored';
                $description = "$obj_type $action from $old_status in <a target='blank' href='$post_link'>$post_title</a>";
                $hook = "restore_comment";
                if (in_array('restore_comment',$logHookList)) {
                    $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                    ualpAddActivityLogDetail($uactid,$comment_detail_ary);
                }
            }
            else {
                $action = 'approved';
                $description = "$obj_type $action in <a target='blank' href='$post_link'>$post_title</a>";
                $hook = "comment_approve";
                if (in_array('comment_approve',$logHookList)) {
                    $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                    ualpAddActivityLogDetail($uactid,$comment_detail_ary);
                }
            }
        }
        else if($new_status == 'unapproved') {
            if($old_status == 'trash' || $old_status == 'spam') {
                $action = 'restored';
                $description = "$obj_type $action from $old_status in <a target='blank' href='$post_link'>$post_title</a>";
                $hook = "restore_comment";
                if (in_array('restore_comment',$logHookList)) {
                    $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                    ualpAddActivityLogDetail($uactid,$comment_detail_ary);
                }
            }
            else {
                $action = "unapproved";
                $description = "$obj_type $action in <a target='blank' href='$post_link'>$post_title</a>";
                $hook = "comment_unapprove";
                if (in_array('comment_unapprove',$logHookList)) {
                    $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                    ualpAddActivityLogDetail($uactid,$comment_detail_ary);
                }
            }
        }
        else if($new_status == 'spam') {
            $action = "spam";
            $description = "$obj_type marked as $action in <a target='blank' href='$post_link'>$post_title</a>";
            $hook = "spam_comment";
            if (in_array('spam_comment',$logHookList)) {
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                ualpAddActivityLogDetail($uactid,$comment_detail_ary);
            }
        }
        else if($new_status == 'trash') {
            $action = "trash";
            $description = "$obj_type moved to $action in <a target='blank' href='$post_link'>$post_title</a>";
            $hook = "trash_comment";
            if (in_array('trash_comment',$logHookList)) {
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                ualpAddActivityLogDetail($uactid,$comment_detail_ary);
            }
        }
    }
}

add_action('transition_comment_status', 'ualpHookStatusComment',10,3); // new

/*
 * Get activity for the user - Update navigation menu
 *
 */
if (!function_exists('ualpHookWpUpdateMenu')){

    function ualpHookWpUpdateMenu() {
        $logHookList = get_option('enableLogHookList');
        if(!isset($_REQUEST["menu"]) || !isset($_REQUEST["action"])) {
            return;
        }
        if($_REQUEST["action"]!= "delete" && $_REQUEST["action"]!= "locations" && $_REQUEST["action"] != "update") {
            return;
        }
        $menu_id = $_REQUEST["menu"];
        if(!is_nav_menu($menu_id)) {
            return;
        }
        $menu_object = wp_get_nav_menu_object($menu_id);
        $obj_type = "Menu";
        $post_id = $menu_id;
        $post_title = $menu_object->name;
        if("delete" == $_REQUEST["action"]) {
            if (in_array('delete_nav_menu',$logHookList)) {
                $action = "deleted";
                $hook = "delete_nav_menu";
                $description = "$post_title $obj_type $action";
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        } elseif("locations" == $_REQUEST["action"]) {
            if (in_array('wp_update_nav_menu',$logHookList)) {
                $action = "location updated";
                $hook = "wp_update_nav_menu";
                $description = "$post_title $obj_type $action";
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        } else {
            if (in_array('wp_update_nav_menu',$logHookList)) {
                $action = "updated";
                $hook = "wp_update_nav_menu";
                $description = "$post_title $obj_type $action";
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        }
    }
}
add_action("load-nav-menus.php", 'ualpHookWpUpdateMenu');

/*
 * Get activity for the user - Create navigation menu
 *
 * @param int $menu Post ID
 *
 */
if (!function_exists('ualpHookWpCreateMenu')){

    function ualpHookWpCreateMenu($menu) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wp_create_nav_menu',$logHookList)) {
            $action = "created";
            $obj_type = "Menu";
            $post_id = $menu;
            $menu_object = wp_get_nav_menu_object($post_id);
            $post_title = $menu_object->name;
            $hook = "wp_create_nav_menu";
            $description = "$post_title $obj_type $action";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}
add_action('wp_create_nav_menu', 'ualpHookWpCreateMenu');

/*
 * Get activity for the user - Create Terms
 *
 * @param string $term term name
 * @param string $taxonomy taxonomy name
 *
 */
if (!function_exists('ualpHookCreatedTerm')){

    function ualpHookCreatedTerm($term, $taxonomy) {
        if ('nav_menu' === $taxonomy)
            return $term;

        $logHookList = get_option('enableLogHookList');
        if (in_array($taxonomy,$logHookList)) {
            $taxonomy_details = get_taxonomy( $taxonomy );
            $action = "created";
            $obj_type = "Term";
            $post_id = "";
            $post_title = $taxonomy." - ".$term;
            $hook = "pre_insert_term";
            $description = "$obj_type '$term' $action in taxonomy '$taxonomy_details->label'";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
        return $term;
    }
}
add_filter('pre_insert_term', 'ualpHookCreatedTerm', 10, 2);

/*
 * Get activity for the user - Delete Terms
 *
 * @param int $term Term ID
 * @param string $taxonomy taxonomy name
 *
 */
if (!function_exists('ualpHookDeleteTerm')){

    function ualpHookDeleteTerm($term, $taxonomy) {
        if ('nav_menu' === $taxonomy)
            return $term;
        if ($taxonomy && !is_wp_error($taxonomy)) {
            $logHookList = get_option('enableLogHookList');
            if (in_array($taxonomy,$logHookList)) {
                $action = 'deleted';
                $obj_type = 'Term';
                $post_id = $term;
                $post_title = "";
                $hook = "pre_delete_term";
                $termName = get_term_by("id", $term, $taxonomy);
                $termLink = get_edit_term_link($term, $taxonomy);
                $taxonomy_details = get_taxonomy( $taxonomy );
                if($taxonomy == "product_shipping_class"){
                    $description = "$obj_type '$termName->name' $action from taxonomy '$taxonomy_details->label'";
                }else{
                    $description = "$obj_type <a target='blank' href='$termLink'>'$termName->name'</a> $action from taxonomy '$taxonomy_details->label'";
                }
                ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        }
    }
}
add_action('pre_delete_term', 'ualpHookDeleteTerm', 10, 2);

/*
 * Get activity for the user - Edit Terms
 *
 * @param int $parent Parent Term Id
 * @param int $term_id Term Id
 * @param string $taxonomy Taxonomy Name
 * @param array $parsed_args Arguments
 * @param array $args Arguments
 * @return int $parent
 *
 */
function ualpHookEditedTerm( $parent = null, $term_id = null, $taxonomy = null, $parsed_args = null, $args = null ) {

    if ('nav_menu' === $args["taxonomy"])
            return;

    $logHookList = get_option('enableLogHookList');
    if (in_array($args["taxonomy"],$logHookList)) {
        $action = "edited";
        $obj_type = "Term";
        $hook = "wp_update_term_parent";
        $old_term = get_term_by("id", $term_id, $taxonomy);
        if (! $args || empty( $old_term)) {
            return $parent;
        }
        $post_id = $term_id;
        $ulap_old_term_name = $old_term->name;
        $ulap_old_term_slug = $old_term->slug;
        $ulap_old_term_description = $old_term->description;
        $ulap_old_term_parent = $old_term->parent;
        $ulap_new_term_name = $args["name"];
        $ulap_new_term_taxonomy = $args["taxonomy"];
        $ulap_new_term_slug = $args["slug"];
        $ulap_new_term_description = $args["description"];
        $ulap_new_term_parent = $args["parent"];

        $post_title = $ulap_new_term_taxonomy." - ". $ulap_new_term_name;
        if($taxonomy == "product_shipping_class"){
            $description = "$obj_type '$ulap_new_term_name' $action in taxonomy '$ulap_new_term_taxonomy'";
        }else{
            $description = "$obj_type <a target='blank' href='".  get_edit_term_link( $term_id, $ulap_new_term_taxonomy )."'>'$ulap_new_term_name'</a> $action in taxonomy '$ulap_new_term_taxonomy'";
        }
        $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        $user_detail_ary = array();
        if($ulap_old_term_name != $ulap_new_term_name) {
            $user_detail_ary['ulap_old_term_name'] = $ulap_old_term_name;
            $user_detail_ary['ulap_new_term_name'] = $ulap_new_term_name;
        }
        if($ulap_old_term_slug != $ulap_new_term_slug) {
            $user_detail_ary['ulap_old_term_slug'] = $ulap_old_term_slug;
            $user_detail_ary['ulap_new_term_slug'] = $ulap_new_term_slug;
        }
        if($ulap_old_term_description != $ulap_new_term_description) {
            $user_detail_ary['ulap_old_term_description'] = $ulap_old_term_description;
            $user_detail_ary['ulap_new_term_description'] = $ulap_new_term_description;
        }
        if($ulap_old_term_parent != $ulap_new_term_parent) {
            $user_detail_ary['ulap_old_term_parent'] = $ulap_old_term_parent;
            $user_detail_ary['ulap_new_term_parent'] = $ulap_new_term_parent;
        }
        ualpAddActivityLogDetail($uactid,$user_detail_ary);
    }
    return $parent;
}
add_filter( 'wp_update_term_parent', 'ualpHookEditedTerm', 10, 5 );

/*
 * Get activity for the user - Switch Theme
 *
 * @param string $themename Theme Name
 * @param object $theme Theme Object
 *
 */

if (!function_exists('ualpHookSwitchTheme')) {

    function ualpHookSwitchTheme($themename,$theme) {
        global $old_theme_data;
        $user = wp_get_current_user();
        $logHookList = get_option('enableLogHookList');
        if (in_array('switch_theme',$logHookList)) {
            $action = "switched";
            $obj_type = "Theme";
            $post_id = "";
            $post_title = $themename;
            $hook = "switch_theme";
            $description = "$obj_type $action : $post_title";
            $new_theme = array(
                'name' => $theme->name,
                'version' => $theme->version
            );
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddActivityLogDetailSwitchTheme($uactid, $old_theme_data, $new_theme);

            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpThemeSwitched', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Theme switched successfully');
            }
        }
    }
}
add_action('switch_theme', 'ualpHookSwitchTheme',2,2);

/*
 * Get activity for the user - Load Theme
 *
 */
if(!function_exists('ualpHookLoadTheme')) {
    function ualpHookLoadTheme() {
        global $old_theme_data;
        if (!isset($_GET["action"]) || $_GET["action"] != "activate") {
            return;
        }
        $current_theme = wp_get_theme();
        if (!is_a($current_theme, "WP_Theme")) {
            return;
        }
        $old_theme_data = array(
            'name' => $current_theme->name,
            'version' => $current_theme->version
        );
    }
}
add_action('load-themes.php', 'ualpHookLoadTheme');

/*
 * Get activity for the user - Customize Theme
 *
 * @param object $instance customize object
 *
 */
if (!function_exists('ualpHookCustomizeSave')){

    function ualpHookCustomizeSave($instance) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('customize_save',$logHookList)) {
            $action = "customize updated";
            $obj_type = "Theme";
            $post_id = "";
            $post_title = "Theme Customizer";
            $hook = "customize_save";
            $description = "$obj_type $action : $post_title";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpHookCustomizeSaveDetail($uactid,$instance);
        }
    }
}

add_action('customize_save', 'ualpHookCustomizeSave', 10, 1); // new

/*
 * Get activity for Theme update or install
 *
 * @param Theme_Upgrader $upgrader
 * @param array $extra
 */
if (!function_exists('ualpHookThemeInstallUpdate')) {

    function ualpHookThemeInstallUpdate($upgrader, $extra) {
        $current_user = wp_get_current_user();

        if (!isset($extra['type']) || 'theme' !== $extra['type'])
            return;
        global $old_theme_data;
        $obj_type = "Theme";
        $post_id = "";
        $logHookList = get_option('enableLogHookList');
        if ('install' === $extra['action']) {
            $slug = $upgrader->theme_info();
            if (!$slug)
                return;

            wp_clean_themes_cache();
            $theme = wp_get_theme($slug);
            $name = $theme->name;
            $version = $theme->version;
            $action = 'installed';
            $hook = "theme_installed";
            $new_theme = array(
                'name' => $theme->name,
                'version' => $theme->version
            );
            $post_title = $name . ' ' . $version;
            $description = "Theme $action : $post_title";
            if (in_array('theme_installed',$logHookList)) {
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                ualpAddActivityLogDetailUpgradeTheme($uactid, $new_theme);
                $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
                if(is_array($ualpUserEmailNotify) && in_array('ualpThemeInstalled', $ualpUserEmailNotify)){
                    ualpSendEmailNotification($current_user->user_login,'Theme installed successfully');
                }
            }
        }
        if ('update' === $extra['action']) {
            if (isset($extra['bulk']) && true == $extra['bulk'])
                $slugs = $extra['themes'];
            else
                $slugs = array($upgrader->skin->theme);

            foreach ($slugs as $slug) {
                $theme = wp_get_theme($slug);
                $stylesheet = $theme['Stylesheet Dir'] . '/style.css';
                $theme_data = get_file_data($stylesheet, array('Version' => 'Version'));
                $name = $theme['Name'];
                $version = $theme_data['Version'];
                $new_theme = array(
                    'name' => $name,
                    'version' => $version
                );
                $action = 'updated';
                $hook = "theme_updated";
            }
            $post_title = $name . ' ' . $version;
            $description = "Theme $action : $post_title";
            if (in_array('theme_updated',$logHookList)) {
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                ualpAddActivityLogDetailUpgradeTheme($uactid, $new_theme);
                $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
                if(is_array($ualpUserEmailNotify) && in_array('ualpThemeUpdated', $ualpUserEmailNotify)){
                    ualpSendEmailNotification($current_user->user_login,'Theme updated successfully');
                }
            }
        }
    }

}
add_action('upgrader_process_complete', 'ualpHookThemeInstallUpdate', 10, 2);

/*
 * Get activity for the user - Delelte theme
 */
if (!function_exists('ualpHookThemeDeleted')){

    function ualpHookThemeDeleted() {
        $current_user = wp_get_current_user();
        $logHookList = get_option('enableLogHookList');
        if (in_array('delete_site_transient_update_themes',$logHookList)) {
            $backtrace_history = debug_backtrace();
            $delete_theme_call = null;
            foreach ($backtrace_history as $call) {
                if (isset($call['function']) && 'delete_theme' === $call['function']) {
                    $delete_theme_call = $call;
                    break;
                }
            }
            if (empty($delete_theme_call))
                return;
            $name = $delete_theme_call['args'][0];
            $action = 'deleted';
            $obj_type = 'Theme';
            $post_title = $name;
            $post_id = "";
            $hook = "delete_themes";
            $description = "Theme $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);

            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpThemeDeleted', $ualpUserEmailNotify)){
                ualpSendEmailNotification($current_user->user_login,'Theme deleted successfully');
            }
        }
    }
}
add_action('delete_site_transient_update_themes', 'ualpHookThemeDeleted');

/*
 * Get activity for the user - update file from editor
 *
 */
if (!function_exists('ualpHookThemeModify')) {

    function ualpHookThemeModify($location, $status) {
        $current_user = wp_get_current_user();
        if (strpos($location, 'theme-editor.php?file=') !== false) {
            if (!empty($_POST) && $_POST['action'] === 'update') {
                $logHookList = get_option('enableLogHookList');
                if (in_array('theme_file_modify',$logHookList)) {
                    $action = "File Updated";
                    $post_title = $_POST['theme'] . " - " . $_POST['file'];
                    $post_id = "";
                    $obj_type = "Theme";
                    $hook = "wp_redirect";
                    $description = "$action : $post_title";
                    ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                    $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
                    if(is_array($ualpUserEmailNotify) && in_array('ualpThemeFileModify', $ualpUserEmailNotify)){
                        ualpSendEmailNotification($current_user->user_login,'Theme file modified successfully');
                    }
                }
            }
        }
        // We are need return the instance, for complete the filter.
        return $location;
    }

}

add_filter('wp_redirect', 'ualpHookThemeModify', 10, 2); // new

/*
 * Get activity for the user - Activate Plugin
 *
 * @param string $plugin Plugin Name
 *
 */
if (!function_exists('ualpHookActivatedPlugin')){

    function ualpHookActivatedPlugin($plugin) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('activated_plugin',$logHookList)) {
            $action = "activated";
            $obj_type = "Plugin";
            $post_id = "";
            $plugin_data = get_plugin_data(WP_PLUGIN_DIR . '/' . $plugin, true, false);
            $post_title = $plugin_data['Name'];
            $hook = "activated_plugin";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);

            $user = wp_get_current_user();
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpPluginActivated', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Plugin activated successfully');
            }
        }
    }
}

add_action('activated_plugin', 'ualpHookActivatedPlugin');

/*
 * Get activity for the user - Deactivate Plugin
 *
 * @param string $plugin Plugin Name
 *
 */
if (!function_exists('ualpHookDeactivatedPlugin')){

    function ualpHookDeactivatedPlugin($plugin) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('deactivated_plugin',$logHookList)) {
            $action = "deactivated";
            $obj_type = "Plugin";
            $post_id = "";
            $plugin_data = get_plugin_data(WP_PLUGIN_DIR . '/' . $plugin, true, false);
            $post_title = $plugin_data['Name'];
            $hook = "deactivated_plugin";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $user = wp_get_current_user();
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpPluginDeactivated', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Plugin deactivated successfully');
            }
        }
    }
}

add_action('deactivated_plugin', 'ualpHookDeactivatedPlugin');

/**
 * Get activity for the user - Delete Plugin
 *
 * @param string $plugin_file file name
 */
if (!function_exists('ualpHookDeletePlugin')){

    function ualpHookDeletePlugin($plugin_file) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('delete_plugin',$logHookList)) {
            $action = "deleted";
            $obj_type = "Plugin";
            $post_id = "";
            $plugin_data = get_plugin_data(WP_PLUGIN_DIR . '/' . $plugin_file, true, false);
            $post_title = $plugin_data['Name'];
            $hook = "delete_plugin";
            $description = "$obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $user = wp_get_current_user();
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpPluginDeleted', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Plugin deleted successfully');
            }
        }
    }
}

add_action('delete_plugin', 'ualpHookDeletePlugin', 10, 1); // new

/**
 * Get activity for the user - Modify Plugin
 *
 * @param string $location
 * @return string $location
 */
if (!function_exists('ualpHookPluginModify')) {

    function ualpHookPluginModify($location) {
        if (strpos($location, 'plugin-editor.php') !== false) {
            if ((!empty($_POST) && 'update' === $_REQUEST['action']) && !empty($_REQUEST['file'])) {

                $plugin_explode = explode( '/', $_REQUEST['file'] );
                $pluginData = get_plugins( '/' . $plugin_explode[0] );
                foreach($pluginData as $plugin){
                    $pluginName = $plugin['Name'];
                }
                $logHookList = get_option('enableLogHookList');
                if (in_array('plugin_modify',$logHookList)) {
                    $action = "File Changed";
                    $obj_type = "Plugin";
                    $post_id = "";
                    $post_title = $pluginName ." - ". $_REQUEST['file'];
                    $hook = "wp_redirect";
                    $description = "$obj_type $action : $post_title";
                    ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                    $user = wp_get_current_user();
                    $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
                    if(is_array($ualpUserEmailNotify) && in_array('ualpPluginFileChanged', $ualpUserEmailNotify)){
                        ualpSendEmailNotification($user->user_login,'Plugin file modified successfully');
                    }
                }
            }
        }
        return $location;
    }

}
add_filter('wp_redirect', 'ualpHookPluginModify', 10); // new

/*
 * Get activity for the user - Upgrader process complete
 *
 * @param object $upgrader
 * @param array $extra
 */
if (!function_exists('ualpHooksPluginInstallUpdate')) {

    function ualpHooksPluginInstallUpdate($upgrader, $extra) {
        if (!isset($extra['type']) || $extra['type'] !== 'plugin')
            return;

        $obj_type = "Plugin";
        $post_id = "";
        $logHookList = get_option('enableLogHookList');
        if ($extra['action'] === 'install') {
            $path = $upgrader->plugin_info();
            if (!$path)
                return;

            $data = get_plugin_data($upgrader->skin->result['local_destination'] . '/' . $path, true, false);
            $action = "Installed";
            $post_title = $data['Name'];
            $hook = "plugin_installed";
            $description = "$obj_type $action : $post_title";
            if (in_array('plugin_installed',$logHookList)) {
                ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                $user = wp_get_current_user();
                $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
                if(is_array($ualpUserEmailNotify) && in_array('ualpPluginInstall', $ualpUserEmailNotify)){
                    ualpSendEmailNotification($user->user_login,'Plugin installed successfully');
                }
            }
        }
        if ($extra['action'] === 'update') {
            if (isset($extra['bulk']) && $extra['bulk'] == true) {
                $slugs = $extra['plugins'];
            } else {
                if (!isset($upgrader->skin->plugin))
                    return;
                $slugs = array($upgrader->skin->plugin);
            }
            foreach ($slugs as $slug) {
                $data = get_plugin_data(WP_PLUGIN_DIR . '/' . $slug, true, false);
                $action = "Updated";
            }
            $post_title = $data['Name'];
            $hook = "plugin_updated";
            $description = "$obj_type $action : $post_title";
            if (in_array('plugin_updated',$logHookList)) {
                ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                $user = wp_get_current_user();
                $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
                if(is_array($ualpUserEmailNotify) && in_array('ualpPluginUpdated', $ualpUserEmailNotify)){
                    ualpSendEmailNotification($user->user_login,'Plugin updated successfully');
                }
            }
        }
    }

}
add_action('upgrader_process_complete', 'ualpHooksPluginInstallUpdate', 10, 2); // new

/*
 * Get activity for the user - Export wordpress data
 *
 * @param array $args
 */
if (!function_exists('ualpHookExportWp')){

    function ualpHookExportWp($args) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('export_wp',$logHookList)) {
            $action = "Downloaded";
            $obj_type = "Export";
            $post_id = "";
            $post_title = isset( $args['content'] ) ? $args['content'] : 'all';
            $hook = "export_wp";
            $description = "$obj_type file $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $user = wp_get_current_user();
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpExportData', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Wordpress data exported successfully');
            }
        }
    }
}

add_action('export_wp', 'ualpHookExportWp');

/*
 * Get activity for the user - Import wordpress data
 *
 */
if (!function_exists('ualpHookImportWp')){

    function ualpHookImportWp() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('import_end',$logHookList)) {
            $action = "Wordpress";
            $obj_type = "Import";
            $post_id = "";
            $post_title = $obj_type;
            $hook = "import_end";
            $description = "$obj_type $action data";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);

            $user = wp_get_current_user();
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpImportData', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Wordpress data imported successfully');
            }

        }
    }
}

add_action('import_end', 'ualpHookImportWp'); // new

/*
 * Get activity for the user - Save Post
 *
 * @param int $post_id post id
 * @param object $post current post
 *
 */
if (!function_exists('ualpHookSavePostStatus')){

    function ualpHookSavePostStatus($post_id, $post) {
        global $old_post_data;
        $obj_type = $post->post_type;
        $logHookList = get_option('enableLogHookList');
        $old_post_data_detail = $old_post_data['post_data'];
        if(isset($old_post_data_detail) && $old_post_data_detail != ''){
            $oldstatus = $old_post_data_detail->post_status;
        }
        $newstatus = $post->post_status;
        $old_status = isset($oldstatus) ? $oldstatus : '';
        $new_status = isset($newstatus) ? $newstatus : '';
        if (in_array($obj_type,$logHookList) && $obj_type != 'edd_discount') {
            if ("nav_menu_item" == get_post_type($post) || "wpcf7_contact_form" == get_post_type($post) || wp_is_post_revision($post) || $obj_type == 'customize_changeset') {
                return;
            }
            $post_id = $post->ID;
            $post_title = $post->post_title;
            $action = "";

            if ( 'auto-draft' === $new_status || ( 'new' === $old_status && 'inherit' === $new_status ) ) {
                return;
            }
            elseif ( 'auto-draft' === $old_status && $new_status === 'draft' ) {
                $action = 'drafted';
            }
            elseif ( 'draft' === $old_status && $new_status === 'publish' && $old_post_data['post_data']->post_date_gmt === '0000-00-00 00:00:00') {
                $action = 'created';
            }
            elseif ( 'trash' === $new_status ) {
                $action = 'trashed';
            }
            elseif ( 'trash' === $old_status ) {
                $action = 'restored';
            }
            else {
                $action = 'updated';
            }

            if(("forum" == get_post_type($post) || "download" == get_post_type($post)) && ($action == 'drafted')){
                return;
            }

            if ( wp_is_post_revision( $post_id ) )
                return;

            $hook = "transition_post_status";
            $page_link = get_edit_post_link($post_id);
            if($page_link == ''){
                $page_link = get_the_permalink($post_id);
            }
            $description = "$obj_type $action : <a target='blank' href='". $page_link."'>$post_title</a>";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            $post_type = $post->post_type;
            $post_tax = '';
            if($post_type != '' && $post_type != 'nav_menu_item') {
                $taxonomy_names = get_object_taxonomies( $post_type );
                if(is_array($taxonomy_names) && !empty($taxonomy_names)) {
                    foreach($taxonomy_names as $taxonomy_name) {
                        $post_cats = wp_get_post_terms($post_id, $taxonomy_name);
                        $post_cats_ids = array();
                        foreach($post_cats as $post_cat) {
                            $post_cats_ids[] = $post_cat->term_id;
                        }
                        if(is_array($post_cats_ids) && !empty($post_cats_ids)) {
                            $post_tax[$taxonomy_name] = $post_cats_ids;
                        }
                    }
                }
            }
            $new_post_data = array(
                "post_data" => $post,
                "post_meta" => get_post_custom($post_id),
                "post_tax" => $post_tax
            );
            ualpAddActivityLogDetailPostUpdate($uactid,$old_post_data,$new_post_data,$post_type);
        }
    }
}

add_action('save_post', 'ualpHookSavePostStatus', 100, 2);


/*
 * Get activity for the user - Before Save Post
 *
 * @param int $post_ID post id
 *
 */

if(!function_exists('ualpHookBeforeEditPost')) {

    function ualpHookBeforeEditPost($post_ID) {
        global $old_post_data;
        if (!current_user_can('edit_post',$post_ID)) {
            return;
        };
        $prev_post_data = get_post($post_ID);
        $post_type = $prev_post_data->post_type;
        $post_tax = '';
        if($post_type != '' && $post_type != 'nav_menu_item') {
            $taxonomy_names = get_object_taxonomies( $post_type );
            if(is_array($taxonomy_names) && !empty($taxonomy_names)) {
                foreach($taxonomy_names as $taxonomy_name) {
                    $post_cats = wp_get_post_terms($post_ID, $taxonomy_name);
                    $post_cats_ids = array();
                    foreach($post_cats as $post_cat) {
                        $post_cats_ids[] = $post_cat->term_id;
                    }
                    if(is_array($post_cats_ids) && !empty($post_cats_ids)) {
                        $post_tax[$taxonomy_name] = $post_cats_ids;
                    }
                }
            }
        }
        $old_post_data = array(
            "post_data" => $prev_post_data,
            "post_meta" => get_post_custom($post_ID),
            "post_tax" => $post_tax
        );
    }
}
add_action("pre_post_update","ualpHookBeforeEditPost",10);

/**
 * Get activity for the user - Delete Post
 *
 * @param int $pid Post Id
 */
if(!function_exists('ualpHookDeletePost')){

    function ualpHookDeletePost( $pid ) {
        $logHookList = get_option('enableLogHookList');
        global $post_type,$wpdb;
        if (in_array($post_type,$logHookList)) {
            if(did_action( 'before_delete_post' ) == 1){
                $action = "deleted";
                $obj_type = $post_type;
                $post_id = $pid;
                $post_title = get_the_title($pid);
                $hook = "before_delete_post";
                $description = "$obj_type $action permanently: $post_title";
                ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        }
    }
}
add_action( 'before_delete_post', 'ualpHookDeletePost', 10 , 1 );

/*
 * Get activity for the user - Widget update
 *
 * @param object $instance
 * @param object $new_instance
 * @param object $old_instance
 * @param object $widget_instance
 * @return object $instance
 */
if (!function_exists('ualpHookWidgetUpdate')) {
    function ualpHookWidgetUpdate($instance, $new_instance, $old_instance, $widget_instance) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('widget_update_callback',$logHookList)) {
            if (empty($old_instance)) {
                return $instance;
            }
            $action = "updated";
            $obj_type = "Widget";
            $post_id = "";
            $post_title = $widget_instance->name;
            $hook = "widget_update_callback";
            $sidebar_id = $_POST["sidebar"];
            $sidebar = false;
            $sidebars = isset($GLOBALS['wp_registered_sidebars']) ? $GLOBALS['wp_registered_sidebars'] : false;
            $sidebar_name = '';
            if ($sidebars) {
                if (isset($sidebars[$sidebar_id])) {
                    $sidebar = $sidebars[$sidebar_id];
                }
            }
            if ($sidebar) {
                $sidebar_name = $sidebar["name"];
            }
            $description = "$post_title $obj_type $action in $sidebar_name";
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpHookWidgetUpdateDetail($uactid,$instance, $new_instance, $old_instance, $widget_instance);
        }
        return $instance;
    }
}
add_filter('widget_update_callback', 'ualpHookWidgetUpdate', 8, 4);

/*
 * Get activity for the user - Widget Add Delete
 */
if(!function_exists('ualpHookWidgetAddedDeleted')) {
    function ualpHookWidgetAddedDeleted() {
        if ((isset($_POST["add_new"]) && !empty($_POST["add_new"]) && isset($_POST["sidebar"]) && isset($_POST["id_base"])) || isset($_POST["delete_widget"])) {
            $obj_type = "Widget";
            $post_id = "";
            $hook = "sidebar_admin_setup";
            $widget_id_base = $_POST["id_base"];
            $widget = false;
            $widget_detail_ary = array();
            $widget_factory = isset($GLOBALS["wp_widget_factory"]) ? $GLOBALS["wp_widget_factory"] : false;
            if ($widget_factory) {
                foreach ($widget_factory->widgets as $one_widget) {
                    if ($one_widget->id_base == $widget_id_base) {
                        $widget = $one_widget;
                    }
                }
            }
            if ($widget) {
                $post_title = $widget->name;
                $widget_detail_ary["ualp_widget_name_translated"] = $widget->name;
                $widget_detail_ary["ualp_widget_id_base"] = $widget_id_base;
            }
            $sidebar_id = $_POST["sidebar"];
            $sidebar = false;
            $sidebars = isset($GLOBALS['wp_registered_sidebars']) ? $GLOBALS['wp_registered_sidebars'] : false;
            if ($sidebars) {
                if (isset($sidebars[$sidebar_id])) {
                    $sidebar = $sidebars[$sidebar_id];
                }
            }
            if ($sidebar) {
                $sidebar_name = $sidebar["name"];
                $widget_detail_ary["ualp_sidebar_name_translated"] = $sidebar["name"];
                $widget_detail_ary["ualp_sidebar_id"] = $sidebar_id;
            }
            if(isset($_POST["delete_widget"])) {
                $action = "removed";
                $description = "$obj_type $post_title '$action' from '$sidebar_name'";
            }
            else {
                $action = "added";
                $description = "$obj_type $post_title '$action' in '$sidebar_name'";
            }
            $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            ualpAddActivityLogDetail($uactid, $widget_detail_ary);
        }
    }
}
add_action("sidebar_admin_setup", 'ualpHookWidgetAddedDeleted');

/*
 * Get activity for the user - Core file updated successfully
 *
 * @param float $wp_version Wordpress Version
 */
if (!function_exists('ualpHookCoreUpdated')){

    function ualpHookCoreUpdated($wp_version) {
        $logHookList = get_option('enableLogHookList');
        if (in_array('_core_updated_successfully',$logHookList)) {
            $action = "update";
            $obj_type = "Core";
            $post_id = "";
            $post_title = $wp_version;
            $hook = "_core_updated_successfully";
            $description = "Wordpress $obj_type $action : $post_title";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);

            $user = wp_get_current_user();
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpCoreUpdated', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Core updated successfully');
            }

        }
    }
}

add_action('_core_updated_successfully', 'ualpHookCoreUpdated');

/**
 * Get activity for Admin View
 *
 * @global string $admin_title
 */
if (!function_exists('ualpHookAdminView')){

    function ualpHookAdminView() {
        global $admin_title;
        $currentUrl = ualpGetCurrentAdminPageUrl();
        $currentUrl = urldecode($currentUrl);
        $logHookList = get_option('enableLogHookList');
        if (in_array('admin_head',$logHookList)) {
            $action = "Viewed";
            $obj_type = "Admin Page";
            $post_id = "";
            $post_title = $admin_title;
            $hook = "admin_head";
            $description = "$action $obj_type : <a target='blank' href='$currentUrl'>$post_title</a>";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}

add_action('admin_head', 'ualpHookAdminView'); // new

/**
 * Get activity for Front View
 *
 */
if (!function_exists('ualpHookFrontView')){

    function ualpHookFrontView() {
        $logHookList = get_option('enableLogHookList');
        if (in_array('wp_head',$logHookList)) {
            $action = "Viewed";
            $obj_type = "Page";
            $current_url = "";
            $post_title = "";
            $post_id = "";
            $current_url = ualpGetCurrentAdminPageUrl();
            $current_url = urldecode($current_url);
            if ( is_single() ){
                $post_id = get_the_ID();
                $post_title = get_the_title();
            }else {
                $post_title = $current_url;
            }
            $hook = "wp_head";
            $description = "$action $obj_type : <a target='blank' href='$current_url'>$current_url</a>";
            ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
        }
    }
}

add_action('wp_head', 'ualpHookFrontView'); // new


/*
 * function to add custom actions
 */
if(!function_exists('ualpCustomEventHook')) {
    function ualpCustomEventHook() {
        global $wp_filter;
        $custom_event_data = get_option('custom_event_data');
        if(is_array($custom_event_data) && !empty($custom_event_data)) {
            foreach($custom_event_data as $custom_event_single) {
                $number_of_params = apply_filters('number_of_params_custom_action', '5',$custom_event_single['custom_event_name']);
                $priority = apply_filters('priority_custom_action','10',$custom_event_single['custom_event_name']);
                add_action($custom_event_single['custom_event_name'],'ualpCustomEventAction',$priority, $number_of_params);
            }
        }
    }
}

ualpCustomEventHook();

/*
 * callback function to add custom actions
 */
function ualpCustomEventAction($arg1 = '',$arg2 = '',$arg3 = '',$arg4 = '',$arg5 = '') {
    $custom_par_array = array('arg1'=>$arg1, 'arg2' => $arg2, 'arg3' => $arg3, 'arg4' => $arg4, 'arg5' => $arg5);
    $custom_event_data = get_option('custom_event_data');
    if(is_array($custom_event_data) && !empty($custom_event_data)) {
        foreach($custom_event_data as $custom_event_single) {
            $action = $custom_event_single['custom_event_label'];
            $hook = $custom_event_single['custom_event_name'];
            $obj_type = $custom_event_single['custom_event_type'];
            $description = $custom_event_single['custom_event_description'];
            $description = apply_filters('custom_event_description',$description,$hook, $custom_par_array);
            if(current_action() == $custom_event_single['custom_event_name']) {
                $activity_id = ualpGetActivityLog($action, $obj_type, "", "", $hook,$description );
                do_action('ualpAddCustomEventDetail', $activity_id, $hook, $custom_par_array);
            }
        }
    }
}


/*
 * For ACF Support
 */
if (isset($_POST['nonce']) && wp_verify_nonce($_POST['nonce'], 'export')) {
    if(isset($_POST['acf_posts']) && is_array($_POST['acf_posts']) && !empty($_POST['acf_posts'])) {
        $acf_posts = $_POST['acf_posts'];
        $i = 0;
        $acf_post_data = '';
        foreach($acf_posts as $acf_post) {
            $field_name = get_the_title($acf_post);
            if($i == 0) {
                $acf_post_data .= $field_name;
            }
            else {
                $acf_post_data .= ', '.$field_name;
            }
        }
        $action = "Downloaded";
        $obj_type = "Export";
        $post_id = 0;
        if (isset($_POST['export_to_xml'])) {
            $post_title = 'ACF File Exported to xml';
        }
        elseif (isset($_POST['export_to_php'])) {
            $post_title = 'ACF File Exported to php';
        }
        $hook = "export_acf";
        $description = "$post_title with fields : $acf_post_data";
        ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
    }

}

/*
 * function to add log when options updated
 */
if(!function_exists('ualpUpdateOptions')) {
    function ualpUpdateOptions() {
        $screen = get_current_screen();
        if(isset($_REQUEST['settings-updated']) && $_REQUEST['settings-updated'] == true) {
            $current_url = (isset($_SERVER['HTTPS']) ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
            $current_url  = str_replace("&settings-updated=true","",$current_url);
            $current_url  = str_replace("?settings-updated=true","",$current_url);
            $current_url = substr($current_url, -20);
            $transient_name = 'sp_'.$current_url;
            $settings_page_bbpress = get_transient($transient_name);

            if($settings_page_bbpress != '') {
                $action = "updated";
                $obj_type = "Settings";
                $post_id = "";
                $post_title = $screen->base;
                $hook = "updated_option";
                $description = "$obj_type $action : $post_title";
                $uactid = ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                $oldvalue = $_newvalue = array();
                if(isset($settings_page_bbpress) && is_array($settings_page_bbpress)) {
                    foreach($settings_page_bbpress as $settings_page_bbpress_key=>$settings_page_bbpress_val) {
                        $whitelist_options = ualpGetOptions();
                        if (!in_array($settings_page_bbpress_key, $whitelist_options))
                            return;
                        $oldvalue[$settings_page_bbpress_key] = $settings_page_bbpress_val['old_v'];
                        $_newvalue[$settings_page_bbpress_key] = $settings_page_bbpress_val['new_v'];
                    }
                    ualpAddWordPressSettingsLogDetail($uactid,$oldvalue,$_newvalue,$obj_type,$option='');
                }

            }
            delete_transient($transient_name);
        }
    }
}
add_action('admin_head','ualpUpdateOptions',10);

/**
 * Fires when settings updated
 *
 * @param string $option
 * @param string $oldvalue
 * @param string $_newvalue
 */
if(!function_exists('ualpHookBbpressUpdatedOption')) {
    function ualpHookBbpressUpdatedOption($option, $oldvalue, $_newvalue) {
        $current_url = wp_get_referer();
        $current_url  = str_replace("&settings-updated=true","",$current_url);
        $current_url  = str_replace("?settings-updated=true","",$current_url);
        $current_url = substr($current_url, -20);
        $transient_name = 'sp_'.$current_url;
        $whitelist_options = ualpGetOptions();
        if(in_array($option, $whitelist_options)) {
            $settings_page_bbpress = get_transient($transient_name);
            $settings_page_bbpress[$option] = array('old_v' => $oldvalue, 'new_v' => $_newvalue);
            set_transient($transient_name, $settings_page_bbpress);

            $user = wp_get_current_user();
            $ualpUserEmailNotify = get_option('ualpEmailNotification',true);
            if(is_array($ualpUserEmailNotify) && in_array('ualpSettingsUpdated', $ualpUserEmailNotify)){
                ualpSendEmailNotification($user->user_login,'Settings updated');
            }
        }
    }
}
add_action('updated_option', 'ualpHookBbpressUpdatedOption', 100, 3);

add_filter( 'dbdelta_queries', 'ualpEventDBDeltaQuery', 999, 1 );
add_filter( 'query',  'ualpEventDropQuery', 999, 1 );

if(!function_exists('ualpEventDBDeltaQuery')){
    function ualpEventDBDeltaQuery( $queries ) {
        global $wpdb;
        $type_queries = array(
            'create' => array(),
            'update' => array(),
            'delete' => array(),
        );

        foreach ( $queries as $qry ) {
            $str = explode( ' ', $qry );
            if ( preg_match( '|CREATE TABLE ([^ ]*)|', $qry ) ) {
                if ( $wpdb->get_var( "SHOW TABLES LIKE '" . $str[2] . "'" ) != $str[2] ) {
                    array_push( $type_queries['create'], $str[2] );
                }
            } elseif ( preg_match( '|ALTER TABLE ([^ ]*)|', $qry ) ) {
                array_push( $type_queries['update'], $str[2] );
            } elseif ( preg_match( '|DROP TABLE ([^ ]*)|', $qry ) ) {
                if ( ! empty( $str[4] ) ) {
                    array_push( $type_queries['delete'], $str[4] );
                } else {
                    array_push( $type_queries['delete'], $str[2] );
                }
            }
        }

        if ( ! empty( $type_queries['create'] ) || ! empty( $type_queries['update'] ) || ! empty( $type_queries['delete'] ) ) {
            // Filter $_SERVER array for security.
            $server_array = filter_input_array( INPUT_SERVER );

            $actype = ( isset( $server_array['SCRIPT_NAME'] ) ) ? basename( $server_array['SCRIPT_NAME'], '.php' ) : false;
            $alert_options = ualpGetActionType( $actype );

            foreach ( $type_queries as $query_type => $table_names ) {
                if ( ! empty( $table_names ) ) {
                    $alert_options['TableNames'] = implode( ',', $table_names );
                    $logHookList = get_option('enableLogHookList');
                    if (in_array('dbdelta_queries',$logHookList)) {
                        $action = $query_type;
                        $obj_type = "Database";
                        $post_id = "";
                        $post_title = isset($alert_options['TableNames']) ? "'".$alert_options['TableNames']."'" : '';
                        $hook = "dbdelta_queries";
                        $description = $obj_type .": $post_title table ".$action." successfully";
                        ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
                    }
                }
            }
        }
        return $queries;
    }
}

/**
 * Checks for drop query.
 *
 * @param WP_Query $query - Query object.
 */
if(!function_exists('ualpEventDropQuery')){
    function ualpEventDropQuery( $query ) {
        $table_names = array();
        $str = explode( ' ', $query );

        if ( preg_match( '|DROP TABLE ([^ ]*)|', $query ) ) {
            if ( ! empty( $str[4] ) ) {
                array_push( $table_names, $str[4] );
            } else {
                array_push( $table_names, $str[2] );
            }

            // Filter $_SERVER array for security.
            $server_array = filter_input_array( INPUT_SERVER );

            $actype = ( isset( $server_array['SCRIPT_NAME'] ) ) ? basename( $server_array['SCRIPT_NAME'], '.php' ) : false;
            $alert_options = ualpGetActionType( $actype );
        }

        if ( ! empty( $table_names ) ) {
            $alert_options['TableNames'] = implode( ',', $table_names );
            $logHookList = get_option('enableLogHookList');
            if (in_array('dbdelta_queries',$logHookList)) {
                $action = "deleted";
                $obj_type = "Database";
                $post_id = "";
                $post_title = isset($alert_options['TableNames']) ? "'".$alert_options['TableNames']."'" : '';
                $hook = "query";
                $description = $obj_type .": '$post_title' table ".$action." successfully";
                ualpGetActivityLog($action, $obj_type, $post_id, $post_title, $hook, $description);
            }
        }
        return $query;
    }
}

/**
* Get info by action type.
*
* @param string $actype - Plugins, themes or unknown.
*/
function ualpGetActionType( $actype ) {
    // Filter $_GET array for security.
    $get_array = filter_input_array( INPUT_GET );

    $theme_name = $plugin_file = '';
    $is_themes = 'themes' == $actype;
    $is_plugins = 'plugins' == $actype;

    // Action Plugin Component.
    $alert_options = array();
    if ( $is_plugins ) {
        if ( isset( $get_array['plugin'] ) ) {
                $plugin_file = $get_array['plugin'];
        } else {
            if(isset($get_array['checked']) && !empty($get_array['checked'])){
                $plugin_file = $get_array['checked'][0];
            }
        }
        $plugin_name = basename( $plugin_file, '.php' );
        $plugin_name = str_replace( array( '_', '-', '  ' ), ' ', $plugin_name );
        $plugin_name = ucwords( $plugin_name );
        $alert_options['Plugin'] = (object) array(
                'Name' => $plugin_name,
        );
        // Action Theme Component.
    } elseif ( $is_themes ) {
        if ( isset( $get_array['theme'] ) ) {
                $theme_name = $get_array['theme'];
        } else {
            if(isset($get_array['checked']) && !empty($get_array['checked'])){
                $theme_name = $get_array['checked'][0];
            }
        }
        $theme_name = str_replace( array( '_', '-', '  ' ), ' ', $theme_name );
        $theme_name = ucwords( $theme_name );
        $alert_options['Theme'] = (object) array(
                'Name' => $theme_name,
        );
        // Action Unknown Component.
    } else {
        $alert_options['Component'] = 'Unknown';
    }

    return $alert_options;
}
if(!function_exists('ualpLoggedInUsersupdate')){
    function ualpLoggedInUsersupdate(){
        global $wpdb;
        $logged_in_users = $wpdb->get_results("Select * from ".UALP_LOGIN_TABLENAME." order by time_login desc");
        foreach($logged_in_users as $logged_in_user) {
            $user_id = $logged_in_user->user_id;
            $user_login_status = $logged_in_user->login_status;
            $session_token = $logged_in_user->session_token;
            $enc_session_token = ualpGetCurrentToken($session_token);
            $login_status = 'logout';
            $user_metas = get_user_meta($user_id,'session_tokens',true);
            $total_logins = 0;
            if(is_array($user_metas)) {
                $total_logins = count($user_metas);
                if(array_key_exists($enc_session_token, $user_metas)) {
                    $login_status = 'login';
                }
                $time_logout = current_time('mysql');
                if($user_login_status == 'login' && $login_status =='logout') {
                    $userloginstatus = $wpdb->query("UPDATE ".UALP_LOGIN_TABLENAME." SET login_status = '".$login_status."',time_logout = '".$time_logout."' WHERE session_token = '".$session_token."'")."<br>";
                }
                
            }
        }  
    }
}
add_action( 'init', 'ualpLoggedInUsersupdate' );