<?php
if (!defined('ABSPATH'))
    exit; // Exit if accessed directly

global $wp_version, $wpdb, $ualp_errors, $ualp_success, $settings;
$return = '';
$ualp_wp_auto_update = new ualp_wp_auto_update();
if(isset($_POST['ualp_sbt_purchasecode'])) {
    $sol_username = $_POST['sol_username'];
    $purchase_code = $_POST['sol_purchase_code'];
    $return = $ualp_wp_auto_update->update_license(trim($sol_username),trim($purchase_code));
}
if (isset($_POST['ualp_deregister_purchasecode'])) {
    $sol_username = $_POST['sol_username'];
    $purchase_code = $_POST['sol_purchase_code'];
    $return = $ualp_wp_auto_update->deregister_site(trim($sol_username), trim($purchase_code));
}
$sol_username = get_option('ualp_username');
$purchase_code = get_option('ualp_purchase_code');

?>
<div class="ualp-admin ualp-license-page">
    <?php if($return == 'correct') { ?>
        <div class="updated notice">
            <p><?php esc_html_e( 'License updated successfully.', 'user_activity_log_pro' ); ?></p>
        </div>
    <?php }
    else if($return == 'used') { ?>
        <div class="error notice">
            <p><?php esc_html_e( 'License Key already used.', 'user_activity_log_pro' ); ?></p>
        </div>
    <?php
    }
    else if($return == 'incorrect') { ?>
        <div class="error notice">
            <p><?php esc_html_e( 'Wrong license key.', 'user_activity_log_pro' ); ?></p>
        </div>
    <?php
    }
    else if ($return == 'unsuccess') {
        ?>
        <div class="error notice">
            <p><?php esc_html_e('Site is not registered with this license key.', 'user_activity_log_pro'); ?></p>
        </div>
        <?php
    }
    else if ($return == 'success') {
        ?>
        <div class="updated notice">
            <p><?php esc_html_e('Site has been De-Registered successfully.', 'user_activity_log_pro'); ?></p>
        </div>
        <?php
    }
    ?>
    <h1 class="ualp-logo" style="background-color:#344050" title="<?php esc_attr_e('User Activity Log PRO', 'user_activity_log_pro'); ?>">
        <a class="ualp-logo-a" href="<?php echo admin_url('admin.php?page=ual_pro'); ?>" title="<?php esc_html_e('User Activity Log PRO', 'user_activity_log_pro'); ?>">
            <img style="vertical-align: middle;" src="<?php echo UALP_PLUGIN_URL . 'assets/images/Logo.png'; ?>" alt="<?php esc_html_e('User Activity Log PRO', 'user_activity_log_pro'); ?>" />
        </a>
        <div class="ualp-header-meta">
            <a href="http://support.solwininfotech.com/" target="_blank"><?php esc_html_e('24/7 Free Support', 'user_activity_log_pro'); ?></a><br>
            <a href="http://useractivitylog.solwininfotech.com/" target="_blank"><?php esc_html_e('Demo', 'user_activity_log_pro'); ?></a> | <a href="https://www.solwininfotech.com/documents/wordpress/user-activity-log-pro/" target="_blank"><?php esc_html_e('Help?', 'user_activity_log_pro'); ?></a>
        </div>
    </h1>
    <div class="ualp-panel-wrapper">
        <div class="ualp-panel-header">
            <h2><?php esc_html_e( 'License Key', 'user_activity_log_pro' ); ?></h2>
        </div>
        <div class="ualp-panel-body">
            <form method="post" name="ualp_frm_purchasecode" id="ualp_frm_purchasecode">
                <div class="ualp-panel-width">
                    <div class="ualp-txt-lable"><?php esc_html_e( 'Username', 'user_activity_log_pro' ); ?></div>
                    <div class="ualp-control-input">
                        <input value="<?php echo $sol_username; ?>" required="" type="text" name="sol_username" id="sol_username" /><br/>
                        <b><i><small><?php esc_html_e( 'Username will be your registered username with ', 'user_activity_log_pro' ); ?><a target="blank" href="https://codecanyon.net/"><?php echo 'codecanyon' ; ?></a></small></i></b>
                    </div>
                </div>
                <div class="ualp-panel-width">
                    <div class="ualp-txt-lable"><?php esc_html_e( 'License Key', 'user_activity_log_pro' ); ?></div>
                    <div class="ualp-control-input">
                        <input value="<?php echo $purchase_code; ?>" required="" type="password" name="sol_purchase_code" id="sol_purchase_code" />
                    </div>
                </div>
                <div class="ualp-panel-width" style="margin: 0;">
                    <div class="ualp-control-button">
                        <input class="ualp-btn-success" type="submit" value="<?php echo ($sol_username!='') ? esc_attr__( 'Update License', 'user_activity_log_pro' ) : esc_attr__( 'Add License', 'user_activity_log_pro' ) ?>" name="ualp_sbt_purchasecode" />
                        <?php if($sol_username != '') { ?>
                            <input class="ualp-btn-error" type="submit" value="<?php echo esc_html__('De-Register Site', 'user_activity_log_pro'); ?>" name="ualp_deregister_purchasecode" />
                        <?php } ?>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <div class="ualp-panel-wrapper ualp-panel-wrapper-block" style="float: right;">
        <div class="ualp-panel-header">
            <h2><?php esc_html_e( 'How To get Purchase code?', 'user_activity_log_pro' ); ?></h2>
        </div>
        <div class="ualp-panel-body ualp-get-license-key">
            <a target="blank" href="<?php echo esc_url('https://help.market.envato.com/hc/en-us/articles/202822600-Where-Is-My-Purchase-Code'); ?>"> <?php esc_html_e('Click here', 'user_activity_log_pro'); ?> </a> <?php esc_html_e('to know how to get purchase code.', 'user_activity_log_pro'); ?>
        </div>
    </div>
</div>
