<?php
/*
 * Plugin Name: User Activity Log Pro
 * Plugin URI: https://www.solwininfotech.com/product/wordpress-plugins/user-activity-log-pro/
 * Description: Log the activity of users to monitor your site with actions
 * Author: 20script
 * Author URI: https://www.20script.ir/
 * Version: 1.4
 * Requires at least: 4.1
 * Tested up to: 5.0.2
 * Copyright: Solwin Infotech
 */

/*
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}
/*
 * Define variables
 */
global $externaldb,$wpdb;

$tableprefix = $dbuser = $dbpassword = $dbname = $dbhost = "";
$tableprefix    = get_option('table_prefix');
$dbuser         = get_option('database_username');
$dbpassword     = get_option('database_password');
$dbname         = get_option('database_name');
$dbhost         = get_option('database_hostname');

define('UALP_PLUGIN_DIR', plugin_dir_path(__FILE__));
define('UALP_PLUGIN_URL', plugin_dir_url(__FILE__));

if($tableprefix == '' && $dbname == '' && $dbhost == '' && $dbuser == '' && $dbpassword == ''){
    define('UALP_TABLENAME', $wpdb->prefix.'ualp_user_activity');
    define('UALP_DETAIL_TABLENAME', $wpdb->prefix.'ualp_user_activity_detail');
    define('UALP_LOGIN_TABLENAME', $wpdb->prefix.'ualp_user_activity_login');
} else {
    $db = new wpdb($dbuser, $dbpassword, $dbname, $dbhost);
    if (mysqli_connect_errno()){
        define('UALP_TABLENAME', $wpdb->prefix.'ualp_user_activity');
        define('UALP_DETAIL_TABLENAME', $wpdb->prefix.'ualp_user_activity_detail');
        define('UALP_LOGIN_TABLENAME', $wpdb->prefix.'ualp_user_activity_login');
    } else {
        define('UALP_TABLENAME', $tableprefix.'ualp_user_activity');
        define('UALP_DETAIL_TABLENAME', $tableprefix.'ualp_user_activity_detail');
        define('UALP_LOGIN_TABLENAME', $tableprefix.'ualp_user_activity_login');
    }
}

include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
include_once( ABSPATH . WPINC . '/pluggable.php' );

include(UALP_PLUGIN_DIR . 'includes/ualp-list-table.php');
include(UALP_PLUGIN_DIR . 'includes/ualp-common-functions.php');
include(UALP_PLUGIN_DIR . 'includes/ualp-hooks.php');
include(UALP_PLUGIN_DIR . 'includes/ualp-log-detail.php');
include(UALP_PLUGIN_DIR . 'includes/ualp-settings-menu.php');
include(UALP_PLUGIN_DIR . 'includes/ualp-settings-tab.php');
include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-user-activity-log-pro.php');
include(UALP_PLUGIN_DIR . 'includes/ualp-export-logs.php');
include(UALP_PLUGIN_DIR . 'includes/ualp-db-integration.php');

if (is_plugin_active('blog-designer-pro/blog-designer-pro.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-blog-designer-pro.php');
}
if (is_plugin_active('all-in-one-reservation/all-in-one-reservation.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-allinone-reservation.php');
}
if (is_plugin_active('portfolio-designer/portfolio-designer.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-portfolio-designer.php');
}
if (is_plugin_active('wc-checkout-fields-editor/wc-checkout-fields-editor.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-wc-checkout-fields-editor.php');
}
if (is_plugin_active('woocommerce/woocommerce.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-woocommerce.php');
}
if (is_plugin_active('gravityforms/gravityforms.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-gravityform.php');
}
if (is_plugin_active('autoptimize/autoptimize.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-autoptimizer.php');
}
if (is_plugin_active('bbpress/bbpress.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-bbpress.php');
}
if (is_plugin_active('wordfence/wordfence.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-wordfence.php');
}
if (is_plugin_active('wordpress-seo/wp-seo.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-wordpress-seo.php');
}
if (is_plugin_active('easy-digital-downloads/easy-digital-downloads.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-easy-digital-download.php');
}
if (is_plugin_active('contact-form-7/wp-contact-form-7.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-contact-form-7.php');
}
if (is_plugin_active('users-ultra/xoousers.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-userultra.php');
}
if (is_plugin_active('user-switching/user-switching.php')) {
    include(UALP_PLUGIN_DIR . 'includes/ualp-hooks-user-switching.php');
}

$externaldb = ualpExternal();

register_activation_hook(__FILE__,'ualpDeactivateUal');

add_action('current_screen', 'ualpFooterAdv');
add_action('user_register', 'ualpEnableUserForNotification');

$plugin = plugin_basename( __FILE__ );
add_filter( "plugin_action_links_$plugin", 'ualpAddSettingsLink' );

add_action('plugins_loaded', 'ualpLoadTextDomain');
add_action('plugins_loaded', 'latest_news_solwin_feed');

add_action('init', 'ualpSetRoleManager',6);
add_action('init', 'ualpFilterUserRole');
add_action('init', 'ualpSessionStart');

add_action('admin_init', 'ualpDeleteLogOnce');

if(!function_exists('ualpDeleteLogOnce')){
    function ualpDeleteLogOnce(){
        $yesterday_date = date("Y-m-d",strtotime('yesterday'));
        $today_date = date("Y-m-d");
        $ualp_last_delete_log_date = get_option('ualp_last_delete_log_date');
        if(!isset($ualp_last_delete_log_date) || $ualp_last_delete_log_date == ''){
            update_option('ualp_last_delete_log_date',$yesterday_date );
        }

        $ualp_last_delete_log_date = get_option('ualp_last_delete_log_date');

        if($ualp_last_delete_log_date != $today_date){
            ualpDeleteLog();
            update_option('ualp_last_delete_log_date',$today_date );
        }
    }
}

add_action('activate_plugin', 'ualpCreateTable',2);
add_action('activate_plugin', 'ualpCreateDetailTable',4);
add_action('activate_plugin', 'ualpSetDefaultLogHook',8);
add_action('activated_plugin', 'ualpRedirect', 10, 2);

add_action('admin_notices', 'ualpDatabaseUpgrade');

add_action('admin_head', 'ualpDialogboxContent');
add_action('admin_head', 'ulapGetAdminPwd');
add_action('admin_init', 'ualpActivate');
add_action('admin_init', 'ualpResetDatabaseSettings');

add_action('admin_enqueue_scripts', 'ualpAdminStyles');
add_action('admin_enqueue_scripts', 'ualpAdminScripts');

add_action('wp_ajax_compareLogPassword', 'ualpCompareLogPassword');
add_action('wp_ajax_downloadLogFile', 'ualpDeleteUalpTable');
add_action('wp_ajax_downloadSingleLog', 'ualpDeleteSingleLog');
add_action('wp_ajax_downloadBulkLog', 'ualpDeleteBulkLog');
add_action('wp_ajax_viewDetailLog', 'ualpViewUpdateDetail');
add_action('wp_ajax_ualpFavoriteLog', 'ualpAjaxFavoriteLog');
add_action('wp_ajax_ualpSessionExpire', 'ualpSessionExpire');
/**
 * create shortcode for particular user
 */
function ualp_shortcodes_init(){
    add_shortcode('ualp_userhistory', 'ualp_shortcode');
}
add_action('init', 'ualp_shortcodes_init');
/**
 * Load plugin text domain (user_activity_log_pro)
 */
if (!function_exists('ualpLoadTextDomain')) {

    function ualpLoadTextDomain() {
        load_plugin_textdomain('user_activity_log_pro', false, dirname(plugin_basename(__FILE__)) . '/languages');
    }

}

/**
 * License Key
 */
if(!function_exists('ualpLicenseKey')) {
    function ualpLicenseKey() {
        include_once UALP_PLUGIN_DIR . 'includes/version-and-api.php';
    }
}

if(!function_exists('ualpActivate')) {
    function ualpActivate() {
        include_once UALP_PLUGIN_DIR . 'includes/wp-autoupdate.php';
        new ualp_wp_auto_update();
    }
}
function ualp_shortcode($atts = [],$content = null,$tag = '') {
    $atts = array_change_key_case((array)$atts, CASE_LOWER);
    $ualp_atts = shortcode_atts(['id' => '1'], $atts,$tag );
    global $wpdb;
    if(function_exists('is_multisite') && is_multisite()){
        $table_name = $wpdb->base_prefix."ualp_user_activity";
    } else {
        $table_name = $wpdb->prefix."ualp_user_activity";
    }
    $total_items_query = "SELECT * FROM " . $table_name . " WHERE user_id=". $ualp_atts['id'];
     
    $results = $wpdb->get_results($total_items_query);
        echo "<table class='user_history'>";
        echo "<tr>";
        echo "<th>Date</th>";
        echo "<th>User Name</th>";
        echo "<th>Hook</th>";
        echo "<th>Type</th>";
        echo "<th>Description</th>";
        echo "</tr>";

        foreach($results as $key=>$value) {
            echo "<tr>";
            echo "<td>". $value->modified_date ."</td>";
            echo "<td>". $value->user_name ."</td>";
            echo "<td>". $value->hook ."</td>";
            echo "<td>". $value->object_type ."</td>";
            echo "<td>". $value->description ."</td>";
            echo "</tr>";
        }

        echo "</table>";
   
}